set(0,'DefaultAxesFontSize',18)
set(0,'DefaultLineLinewidth',2)
set(0,'Defaulttextinterpreter','latex')
clear

% Specify locations of model spectra:
m43 = fopen('/Users/anders/projects/SN2011dh/finishedmodels/43/fluxes43')  % 13(33,41)  m43 becomes just an integer
m45 = fopen('/Users/anders/projects/SN2011dh/finishedmodels/45/fluxes45')  % 15
m46 = fopen('/Users/anders/projects/SN2011dh/finishedmodels/46/fluxes46') % 12(34
m47 = fopen('/Users/anders/projects/SN2011dh/finishedmodels/47/fluxes47')  % 15
m49 = fopen('/Users/anders/projects/SN2011dh/finishedmodels/49/fluxes49')
m50 = fopen('/Users/anders/projects/SN2011dh/finishedmodels/50/fluxes50')
m51 = fopen('/Users/anders/projects/SN2011dh/finishedmodels/51/fluxes51')  % 15
m52 = fopen('/Users/anders/projects/SN2011dh/finishedmodels/52/fluxes52')
m54 = fopen('/Users/anders/projects/SN2011dh/finishedmodels/54/fluxes54')
m55 = fopen('/Users/anders/projects/SN2011dh/finishedmodels/55/fluxes55')
m56 = fopen('/Users/anders/projects/SN2011dh/finishedmodels/56/fluxes56')
m57 = fopen('/Users/anders/projects/SN2011dh/finishedmodels/57/fluxes57')
m58 = fopen('/Users/anders/projects/SN2011dh/finishedmodels/58/fluxes58')
m59 = fopen('/Users/anders/projects/SN2011dh/finishedmodels/59/fluxes59')
m60 = fopen('/Users/anders/projects/SN2011dh/finishedmodels/60/fluxes60')

% Select which models to plot:
plotsel = {'m49','m55','m59','m43','m46','m50','m51','m52','m60','m56'}
%plotsel = {'m50','m51'}
main = 2  % Select one model for some special plots

nimasswhensame = 0.075   % This is not the actual mass in the model, just the factor to normalize all plots with
							 
dist_MPc = 7.8; % Distance
DF = 4*pi*(dist_MPc*1e6*3.086e18)^2;

tminplot = 100.;
modelend = 500;

% ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

Nmodels = length(plotsel);
c = 3e10;
h = 6.626e-27;
k = 1.38e-16;
forestgreen = [0, 0.5, 0]

bandcenters = [3616, 4419, 5524, 6599, 8028, 12410, 16513, 21656, 35701, 45228]; % U B V R I J H K SPITZ3.6. M ergon mail Oct 4 2013
bandcentersloanr = 6206   % M ergon priv comm mail oct 4 2013

FrefU = 10^(-20.96/2.5);
FrefB = 10^(-20.46/2.5);
FrefV = 10^(-21.09/2.5);
FrefR = 10^(-21.65/2.5); 
FrefI = 10^(-22.33/2.5);
FrefJ = 10^(-23.76/2.5);
FrefH = 10^(-24.86/2.5);
FrefK = 10^(-25.92/2.5);
FrefS1 = 10^(-27.94/2.5);
FrefS2 = 10^(-28.93/2.5);
Frefrsloan = 10^(-21.36/2.5);  % M Ergon priv comm

% ------------------------------

Ntimesmax = 10
Lengthmax = 1000

A = zeros(Nmodels,Ntimesmax,Lengthmax);

Ltot = zeros(Nmodels,Ntimesmax);

for i = 1:Nmodels

    fiduse = cell2mat(plotsel(i))  % Transform from cell to matrix type

    clear ATEMP	

    switch fiduse
      case 'm49' 
        Nuse = 742;
        sel = m49;
        Nr = 26;
        M2(i) = {'12A'}
        nimass(i) = 0.075;
      case 'm43' 
        Nuse = 742;
        sel = m43;
        Nr = 26;
        M2(i) = {'13A'}
        nimass(i) = 0.075;
      case 'm46'
        sel = m46;
        Nuse = 742;
        Nr = 26;
        M2(i) = {'13B'}
        nimass(i) = 0.075;
      case 'm47'
        sel = m47;
        Nuse = 742;
        Nr = 26;
        M2(i) = {'47'}
        nimass(i) = 0.075;
      case 'm45'
        sel = m45;
        Nuse = 742;
        Nr = 26
        M2(i) = {'45'}
        nimass(i) = 0.060;
      case 'm50'
        sel = m50;
        Nuse = 741 + 26*3;
        Nr = 29; 
        M2(i) = {'13C'}
        nimass(i) = 0.075;
      case 'm51'
        sel = m51;
        Nuse = 742 + 26*3;
        Nr = 29; 
        M2(i) = {'13D'}
        Vdust(i) = 3500; % The vel covered by dust in the simulation
        xdust(i) = 0.1;  % TEMP A_dust / A_core
        nimass(i) = 0.075;
      case 'm52'
        sel = m52;
        Nuse = 742 + 26*3;
        Nr = 29; 
        M2(i) = {'13E'}
        nimass(i) = 0.075;
      case 'm54'
        sel = m54;
         Nr = 41; 
        Nuse = 66 + 26*Nr;
        M2(i) = {'54'}
        Vdust(i) = 3500; % The vel covered by dust in the simulation
        xdust(i) = 0.1;  % TEMP A_dust / A_core
        nimass(i) = 0.081;
      case 'm55'
        sel = m55;
        Nr = 41; 
        Nuse = 66 + 26*Nr;
        M2(i) = {'12B'}
        Vdust(i) = 3500; % The vel covered by dust in the simulation
        xdust(i) = 0.1;  % TEMP A_dust / A_core
        nimass(i) = 0.078;
      case 'm56'
        sel = m56;
        Nr = 41; 
        Nuse = 66 + 26*Nr;
        M2(i) = {'17A'}
        Vdust(i) = 3500; % The vel covered by dust in the simulation
        xdust(i) = 0.1;  % TEMP A_dust / A_core
        nimass(i) = 0.075;
      case 'm57'
        sel = m57;
        Nr = 41; 
        Nuse = 66 + 26*Nr;
        M2(i) = {'57'}
        Vdust(i) = 3500; % The vel covered by dust in the simulation
        xdust(i) = 0.1;  % TEMP A_dust / A_core
        nimass(i) = 0.081;
      case 'm58'
        sel = m58;
        Nr = 41; 
        Nuse = 66 + 26*Nr;
        M2(i) = {'58'}
        Vdust(i) = 3500; % The vel covered by dust in the simulation
        xdust(i) = 0.1;  % TEMP A_dust / A_core
        nimass(i) = 0.078;
    case 'm59'
        sel = m59;
        Nr = 41; 
        Nuse = 66 + 26*Nr;
        M2(i) = {'12C'}
        Vdust(i) = 3500; % The vel covered by dust in the simulation
        xdust(i) = 0.1;  % TEMP A_dust / A_core
        nimass(i) = 0.078;
    case 'm60'
        sel = m60;
        Nr = 29; 
        Nuse = 66 + 26*Nr;
        M2(i) = {'13F'}
        Vdust(i) = 3500; % The vel covered by dust in the simulation
        xdust(i) = 0.1;  % TEMP A_dust / A_core
        nimass(i) = 0.078;
    end
		              
    ATEMP = fscanf(sel,'%f',[Nuse Inf]);
    
    Ntimes_temp = size(ATEMP,2)	% How many times?
 
    A(i,1:Ntimes_temp,1:Nuse) = ATEMP';  % Enter into big array
		
    Nepochs(i) = Ntimes_temp;

    Nentries(i) = Nuse;
		  
    Ldecay(i,1:Ntimes_temp) = 1.06e42*(nimass(i)/0.075)*(exp(-ATEMP(2,:)/111.4) - exp(-ATEMP(2,:)/8.8))/(4*pi*(dist_MPc*1e6*3.086e18)^2); 

    tcol(i) = 2;
    bolcol(i) = 3; 
    fcol(i) = 4;
    Ucol(i) = 5;
    Bcol(i) = Ucol(i)+1;
    Vcol(i) = Ucol(i)+2;
    Rcol(i) = Ucol(i)+3;
    Icol(i) = Ucol(i)+4;
    Jcol(i) = Ucol(i)+5;
    Hcol(i) = Ucol(i)+6;
    Kcol(i) = Ucol(i)+7;
    S1col(i) = Ucol(i) + 8;
    S2col(i) = Ucol(i) + 9;
    Mgcol(i) = S2col(i) + 1;
    Nacol(i) = S2col(i) + 2;
    Oicol(i) = S2col(i) + 3;
    Hacol(i) = S2col(i) + 4;
    Fecol(i) = S2col(i) + 5;
    Ca7300col(i) = S2col(i) + 6;
    Ca8500col(i) = S2col(i) + 7;
    sicol(i) = S2col(i) + 8;
    %mgircol(i) = S2col(i) + 9;
    ccol(i) = S2col(i) + 10;
    o5577col(i) = S2col(i) + 11;
    mgircol(i) = S2col(i) + 12;
    % ----------------------
    dustcol(i) = S2col(i) + 16;
    tempcol(i) = dustcol(i) + 1  ;
    %
    Mgnocont_col(i) = tempcol(i) + Nr;
    Nanocont_col(i) = Mgnocont_col(i) + 1;
    Oinocont_col(i) = Mgnocont_col(i) + 2;
    Hanocont_col(i) = Mgnocont_col(i) + 3;
    Fenocont_col(i) = Mgnocont_col(i) + 4;
    Ca7300nocont_col(i) = Mgnocont_col(i) + 5;
    Ca8500nocont_col(i) = Mgnocont_col(i) + 6;
    % -----------------------
    acoolcol(i) = Ca8500nocont_col(i)+1; 
    depfraccol(i) = acoolcol(i) + Nr;
    hradcol(i) = depfraccol(i) + Nr;
    hntcol(i) = hradcol(i) + 1;
    hratiocol(i) = hntcol(i) + 1;
    heatcol(i) = hratiocol(i) + 1;
    ioncol(i) = heatcol(i) + Nr;
    exccol(i) = ioncol(i) + Nr;
    cool7155col(i) = exccol(i) + Nr;
    cool7300col(i) = cool7155col(i) + Nr;
    cool6300col(i) = cool7300col(i) + Nr;
    molcoolSiOcol(i) = cool6300col(i) + Nr;
    molcoolCOcol(i) = molcoolSiOcol(i) + 1;



    % depfrackcol(i) = acoolcol(i) + Nr;
    %hradcol(i) = depfrackcol(i) + Nr;
    % hntcol(i) = hradcol(i) + 1;
    %hratiocol(i) = hradcol(i) + 2;
    %heatcol(i) = hratiocol(i) + 1;
    %ioncol(i) = heatcol(i) + Nr;
    %exccol(i) = ioncol(i) + Nr;
    %cool7155col(i) = exccol(i) + Nr;
    %cool7300col(i) = cool7155col(i) + Nr;
    %cool6300col(i) = cool7300col(i) + Nr;
    %molcoolSiOcol(i) = cool6300col(i) + Nr;
    %molcoolCOcol(i) = molcoolSiOcol(i) + 1;
   

end
%fclose(m43)
%fclose(m46)
%fclose(m45)

% 2011dh photometric data ---------------------------

JDE = 55713;  % Explosion date

%fid = fopen('/Users/anders/data/2011dh/photometry/allphot.dat')
fid = fopen('/Users/anders/projects/SN2011dh/data/phot/sn2011dh-phot.dat') % The git file

%PDATA_cell = textscan(fid,'%f %f %f %f %f %f %f %f %f %f %f %f %f %f %f %f %f %f %f %f %f %f %f %f %f %f %f %f %f %f %f %f %f %f %f %f %f','headerlines',1);
PDATA_cell = textscan(fid,'%f %f %f %f %f %f %f %f %f %f %f %f %f %f %f %f %f %f %f %f %f %f %f %f %f %f %f %f %f %f %f %f %f %f %f %f %f %*s %*s %*s %*s','headerlines',1,'commentstyle','#'); % Ive looked around, seems to be one has to specify in this format, cannot write 37%f or similar..%*s means skip a string
PDATA = cell2mat(PDATA_cell)';


fclose(fid)

 % 2011dh spitzer : 
fid = fopen('/Users/anders/data/2011dh/photometry/sn2011dh-spitzer-tmpl-sub-new2.dat')
fgetl(fid)
fgetl(fid)
SPITZER = fscanf(fid,'%f',[9 Inf]);
timesS1 =SPITZER(1,:) - JDE;
timesS2 = SPITZER(1,:) - JDE;
dataS1 = SPITZER(2,:);
errorS1 = SPITZER(3,:);
dataS2 = SPITZER(4,:);
errorS2 = SPITZER(5,:);
fclose(fid)
					
% SN 1993J data -------Spectra from Asiago and ING----------------------

  m56ni_1993J = 0.09;  % PLot all 1993J line fluxes relative to its
                       % 56Ni luminosity: so need to specify this.
  scalefactor = (3.63/3.7)^2;  % TEMP  All luminosities below were
                               % measured assuming a distance of
                               % 3.7 MPc.

  % Vline = 4500, Vcont = 1.25*Vline
 times1 = [106, 118,   172,  176,   224,  264,   283,  326, 388]  % At 415 days the spectrum starts looking weird, energy imput from CSI
 e1 = [0.067,0.26, 0.33, 0.19, 0.017, 0.029,  0.062, 0.054, 0.05, 0.05]    % 388d only one band exists , 415 data is calibrated but i dont have the data
                                          % 106d=ING 12 july, 
                                          % 118d = Asiago 
                                          %  140d = ING not scaled to photometry
                                          % 172d = Asiago
                                          % 176d = ING
                                          % 224d = ING
                                          % 264d = ING
                                          % 283d = ING
                                          % 326d = ING
					  % 388d = ING, spectrum starts at 5500 A
                                          % 415d = ING
                                          % ING 437d : not scaled to photometry (?)
                                          % ING 463d : not scaled to photometry
  
  L1 = 1.06e42*(exp(-times1/111.4) - exp(-times1/8.8))*(m56ni_1993J*scalefactor/0.075);

  mg4571 = [0, 0, 0, 7.59e38, 9.06e38, 5.84e38, 4.62e38, 2.40e38, 0]*scalefactor  % N/A on 106, 118, 172, 388
  mg4571_l = mg4571.*[0, 0, 0, sqrt((e1(4)^2 + 0.3^2)/2.), sqrt((e1(5)^2 + 0.2^2)/2.), sqrt((e1(6)^2 + 0.1^2)/2.), sqrt((e1(7)^2 + 0.1^2)/2.),  sqrt((e1(8)^2 + 0.2^2)/2.), 0]
  mg4571_u = mg4571.*[0, 0, 0, sqrt((e1(4)^2 + 0.3^2)/2.), sqrt((e1(5)^2 + 0.2^2)/2.), sqrt((e1(6)^2 + 0.1^2)/2.), sqrt((e1(7)^2 + 0.1^2)/2.),  sqrt((e1(8)^2 + 0.2^2)/2.), 0]

  oi5577 = [2.34e39, 2.04e39, 6.32e38, 5.29e38, 0, 0, 0, 0, 0]*scalefactor % Gone on day 224
  oi5577_l = oi5577.*[sqrt((e1(1)^2 + 0.1^2)/2.), sqrt((e1(2)^2 + 0.1^2)/2.), sqrt((e1(3)^2 + 0.1^2)/2.), sqrt((e1(4)^2 + 0.1^2)/2.), 0, 0, 0, 0, 0]
  oi5577_u = oi5577.*[sqrt((e1(1)^2 + 0.1^2)/2.), sqrt((e1(2)^2 + 0.1^2)/2.), sqrt((e1(3)^2 + 0.1^2)/2.), sqrt((e1(4)^2 + 0.1^2)/2.), 0, 0, 0, 0, 0]

  oi6300 = [5.38e39, 6.52e39, 4.67e39, 4.85e39, 4.01e39, 2.45e39, 1.98e39, 9.82e38, 5.01e38]*scalefactor
  oi6300_l = oi6300.*[sqrt((e1(1)^2 + 0.2^2)/2.), sqrt((e1(2)^2 + 0.2^2)/2.), sqrt((e1(3)^2 + 0.2^2)/2.), sqrt((e1(4)^2 + 0.1^2)/2.), sqrt((e1(5)^2 + 0.2^2)/2.), sqrt((e1(6)^2 + 0.1^2)/2.), sqrt((e1(7)^2 + 0.1^2)/2.),  sqrt((e1(8)^2 + 0.1^2)/2.), sqrt((e1(9)^2 + 0.5^2)/2.)]  % DC
  oi6300_u = oi6300.*[sqrt((e1(1)^2 + 0.2^2)/2.), sqrt((e1(2)^2 + 0.2^2)/2.), sqrt((e1(3)^2 + 0.2^2)/2.), sqrt((e1(4)^2 + 0.1^2)/2.), sqrt((e1(5)^2 + 0.2^2)/2.), sqrt((e1(6)^2 + 0.2^2)/2.), sqrt((e1(7)^2 + 0.2^2)/2.),  sqrt((e1(8)^2 + 0.3^2)/2.), sqrt((e1(9)^2 + 0.5^2)/2.)]  % DC

  fe7155 = [0, 0, 6.28e38, 7.72e38, 5.78e38, 3.22e38, 2.70e38, 1.31e38, 0]*scalefactor  % N/a on 106, 118, heavy blend on day 172, 388d
  fe7155_l = fe7155.*[0, 0, sqrt((e1(3)^2 + 0.5^2)/2.), sqrt((e1(4)^2 + 0.3^2)/2.), sqrt((e1(5)^2 + 0.5^2)/2.), sqrt((e1(6)^2 + 0.5^2)/2.), sqrt((e1(7)^2 + 0.3^2)/2.),  sqrt((e1(8)^2 + 0.3^2)/2.), 0]
  fe7155_u = fe7155.*[0, 0, sqrt((e1(3)^2 + 0.2^5)/2.), sqrt((e1(4)^2 + 0.5^2)/2.), sqrt((e1(5)^2 + 0.5^2)/2.), sqrt((e1(6)^2 + 0.5^2)/2.), sqrt((e1(7)^2 + 0.1^2)/2.),  sqrt((e1(8)^2 + 0.3^2)/2.), 0]

  ca7300 = [2.61e39, 2.59e39, 2.01e39, 2.30e39, 1.86e39, 1.17e39, 9.55e38, 4.49e38, 1.81e38]*scalefactor
  ca7300_l = ca7300.*[sqrt((e1(1)^2 + 0.3^2)/2.), sqrt((e1(2)^2 + 0.1^2)/2.), sqrt((e1(3)^2 + 0.1^2)/2.), sqrt((e1(4)^2 + 0.2^2)/2.), sqrt((e1(5)^2 + 0.2^2)/2.), sqrt((e1(6)^2 + 0.2^2)/2.), sqrt((e1(7)^2 + 0.1^2)/2.),  sqrt((e1(8)^2 + 0.2^2)/2.), sqrt((e1(9)^2 + 0.3^2)/2.)]
  ca7300_u = ca7300.*[sqrt((e1(1)^2 + 1^2)/2.), sqrt((e1(2)^2 + 0.1^2)/2.), sqrt((e1(3)^2 + 0.1^2)/2.), sqrt((e1(4)^2 + 0.4^2)/2.), sqrt((e1(5)^2 + 0.3^2)/2.), sqrt((e1(6)^2 + 0.2^2)/2.), sqrt((e1(7)^2 + 0.2^2)/2.),  sqrt((e1(8)^2 + 0.2^2)/2.), sqrt((e1(9)^2 + 0.3^2)/2.)]

  caIR = [1.36e40, 8.16e39, 2.48e39, 3.12e39, 1.50e39, 4.09e38, 3.24e38, 1.50e38, 1.46e38]*scalefactor
  caIR_l = caIR.*[sqrt((e1(1)^2 + 0.2^2)/2.), sqrt((e1(2)^2 + 0.2^2)/2.), sqrt((e1(3)^2 + 0.2^2)/2.), sqrt((e1(4)^2 + 0.2^2)/2.), sqrt((e1(5)^2 + 0.5^2)/2.), sqrt((e1(6)^2 + 0.2^2)/2.), sqrt((e1(7)^2 + 0.2^2)/2.),  sqrt((e1(8)^2 + 0.2^2)/2.), sqrt((e1(9)^2 + 0.5^2)/2.)]
  caIR_u = caIR.*[sqrt((e1(1)^2 + 0.5^2)/2.), sqrt((e1(2)^2 + 0.5^2)/2.), sqrt((e1(3)^2 + 0.5^2)/2.), sqrt((e1(4)^2 + 0.5^2)/2.), sqrt((e1(5)^2 + 0.5^2)/2.), sqrt((e1(6)^2 + 0.3^2)/2.), sqrt((e1(7)^2 + 0.2^2)/2.), sqrt((e1(8)^2 + 0.5^2)/2.), sqrt((e1(9)^2 + 0.5^2)/2.)]

  oi9260 = [1.81e39, 1.42e39, 0, 3.79e38, 0, 0, 0, 0, 0]*scalefactor  % Not there on day 212(5) or 264(7)
  oi9260_l = oi9260.*[sqrt((e1(1)^2 + 0.2^2)/2.), sqrt((e1(2)^2 + 0.2^2)/2.), 0, sqrt((e1(4)^2 + 0.2^2)/2.), 0, 0, 0, 0, 0]
  oi9260_u = oi9260.*[sqrt((e1(1)^2 + 0.2^2)/2.), sqrt((e1(2)^2 + 0.2^2)/2.), 0, sqrt((e1(4)^2 + 0.2^2)/2.), 0, 0, 0, 0, 0]

  deltaTs = [(1-52/60)^2, (1-70/94)^2, (1-142/200)^2, (1-175/200)^2, 0, 0, 0, 0, 0];
 erroroimass_l = sqrt( (oi6300_l./oi6300).^2 + (1 - (3.63-0.14)^2/3.63^2)^2 + (1-1.19/1.52)^2 + deltaTs)  % Delta-L^2 + DeltaD2^2 + Deltaf_reddening^2 + deltaexp(22800/T)^2

% --2011dh data -------------------------------------------------------------------------------

  m56ni_2011dh = 0.075;
  times2 = [88 99, 151, 201, 293, 360, 415];

  L2 = 1.06e42*(exp(-times2/111.4) - exp(-times2/8.8))*(m56ni_2011dh/0.075);

  %mg4571_2 = [0, 2.84e38, 2.94e38, 2.17e38, 1.76e38, 8.81e37, 3.95e37]  % N/A at 100 days. Measure with 3500 km/s, cont=1.5*vcut, distance 7.8 Mpc
  %mg4571_2l = mg4571_2.*[0, 0.5, 0.2, 0.1, 0.1, 0.1, 0.1]
  %mg4571_2u = mg4571_2.*[0, 0.5, 0.2, 0.2, 0.1, 0.2, 0.1]

  %oi5577_2 = [1.13e39, 4.22e38, 1.09e38, 2.31e37, 0, 0, 0]
  %oi5577_2l = oi5577_2.*[0.2, 0.1, 0.5, 0.3, 0, 0, 0]
  %oi5577_2u = oi5577_2.*[0.2, 0.1, 0.1, 0.3, 0, 0, 0] 

  %oi6300_2 = [2.31e39, 2.55e39, 1.80e39, 1.01e39, 4.64e38, 2.50e38, 1.19e38]
  %oi6300_2l = oi6300_2.*[0.4, 0.1, 0.1, 0.1, 0.1, 0.1, 0.1]
  %oi6300_2u = oi6300_2.*[0.4, 0.1, 0.1, 0.15, 0.15, 0.15, 0.15]

  %fe7155_2 = [0, 0, 7.1e37, 3.12e37, 1.91e37, 8.09e36, 2.63e36]
  %fe7155_2l = fe7155_2.*[0, 0, 0.3, 0.1, 0.1, 0.1, 0.1]
  %fe7155_2u = fe7155_2.*[0, 0, 0.3, 1, 0.5, 0.3, 0.3]

  %ca7300_2 = [0, 2.76e39, 1.89e39, 1.01e39, 3.99e38, 1.58e38, 5.37e37]
  %ca7300_2l = ca7300_2.*[0, 0.1, 0.1, 0.1, 0.1, 0.10, 0.1]
  %ca7300_2u = ca7300_2.*[0, 0.3, 0.4, 0.3, 0.4, 0.2, 0.3]

  %caIR_2 = [0, 2.88e39, 8.48e38, 2.54e38, 8.79e37, 3.61e37, 1.33e37]
  %caIR_2l = caIR_2.*[0, 0.2, 0.1, 0.1, 0.2, 0.1, 0.1]
  %caIR_2u = caIR_2.*[0, 0.4, 0.5, 0.3, 0.4, 0.3, 0.3]

 %oi9260_2 = [1.10e39, 3.57e38, 3.94e37, 0, 0, 0, 0, 0, 0, 0];  % 100d, 150d, 200d, 250d: broad red wing not captured. After 250d emission is more at ~9400 A, probably another line (the one that contaminates 9260 at early times)
 %oi9260_2l = oi9260_2.*[0.3, 0.3, 0.3, 0.3, 0, 0, 0, 0, 0, 0];
 %oi9260_2u = oi9260_2.*[1, 1, 1, 7, 0, 0, 0, 0, 0, 0];

 % Measure with 3500 km/s, cont=1.25*vcut, distance 7.8 Mpc ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
 % Is is not so well defined what the errors are. The current
 % description is that these are the errors in the estimated luminosity of
 % the line, assuming that its a single line and that its the
 % blending with the continuum that is the source of the error. If
 % the lines are shifted or outside the cutoff range, this
 % interpretation allows to capture the line luminosity in such
 % error bars as well. Whether to use error bars here or not is a
 % bit about perseonal preference : it is not crazy to either use
 % or not use them.
            
             mg4571_2 = [0, 0,        0,     2.77e38, 1.70e38, 6.70e37, 2.73e37];  % N/A at 100 days, 150days
  mg4571_2l = mg4571_2.*[0, 0,        0,       0.2,    0.1,     0.1,      0.1];
  mg4571_2u = mg4571_2.*[0, 0,        0,       0.3,    0.2,     0.1,      0.1];

            mgir_2 = [8.92e38, 0,       0,       9.72e37,         0,        0,            0];
        mgir_2l = mgir_2.*[0.3, 0, 0, 0.4, 0, 0, 0];
        mgir_2u= mgir_2.*[0.3, 0, 0, 0.2, 0, 0, 0];
             
             oi5577_2 = [0, 9.92e38, 3.69e38, 9.92e37,     0 ,  0,        0]; % indistinct from day 293
  oi5577_2l = oi5577_2.*[0, 0.2,       0.1,      0.2,      0,   0,        0];
  oi5577_2u = oi5577_2.*[0, 0.3,       0.2,      0.2,      0,   0,        0]; 

           
            oi6300_2 = [0, 1.89e39, 2.24e39, 1.67e39, 6.00e38, 1.99e38,  8.38e37];
  oi6300_2l = oi6300_2.*[0, 0.3,     0.1,       0.1,     0.1,     0.1,      0.1];
  oi6300_2u = oi6300_2.*[0, 0.3,     0.3,       0.2,     0.2,    0.15,     0.15];

            
             fe7155_2 = [0, 0,         0,        0,  2.07e37, 6.31e36,  1.88e36]; % N/A at 100, 150 days
  fe7155_2l = fe7155_2.*[0, 0,         0,        0,    0.1,    0.1,     0.1];
  fe7155_2u = fe7155_2.*[0, 0,         0,        0,    0.5,    0.3,     0.3];

            
             ca7300_2 = [0, 3.75e39,  2.57e39, 1.80e39, 5.44e38, 1.19e38, 3.19e37];
  ca7300_2l = ca7300_2.*[0, 0.3,      0.1,     0.1,      0.1,     0.1,    0.1];
  ca7300_2u = ca7300_2.*[0, 0.3,      0.4,     0.4,      0.3,     0.3,    0.3];

              
               caIR_2 = [0, 8.48e39,  0,     7.27e38, 9.62e37, 1.96e37, 6.70e36];
      caIR_2l = caIR_2.*[0, 0.1,      0,      0.2,     0.1,     0.2,     0.1];
      caIR_2u = caIR_2.*[0, 1.0,      0,      0.8,     0.8,     0.6,  0.6];  % red tail is
                 %not captured at all at 100 d

            % 100d, 150d, 200d, 250d: broad red wing not captured. After 250d emission is more at ~9400 A, probably another line (the one that contaminates 9260 at early times)
            oi9260_2 = [0, 5.60e38,    0,   8.18e37,     0,     0,       0]; 
  oi9260_2l = oi9260_2.*[0, 0.3,       0,      0.5,      0,     0, 0];
  oi9260_2u = oi9260_2.*[0, 2,         0,      0.5,      0,     0, 0];

% 2008ax data -------------------------------------------------------------------------------
 
% Vline = 4500 km/s, Vcont = 1.25*Vline
  m56ni_2008ax = 0.1;  % TEMP

times3 = [101, 116, 143, 280, 359];
 e3 = [0.11, 0.038, 0.089, 0.066, 0.27];  % The rms errors to the photometric calibration

 L3 = 1.06e42*(exp(-times3/111.4) - exp(-times3/8.8))*(m56ni_2008ax/0.075);  % Taubenberger, 0.07-0.15 for EBV = 0.4 and distance = 9.6
  
 ca7300_3 = [5.38e39, 5.75e39, 4.45e39, 1.56e39, 2.97e38]  % TEMP redo
 ca7300_3l = ca7300_3.*[sqrt((e3(1)^2 + 0.1^2)/2.), sqrt((e3(2)^2 + 0.1^2)/2.), sqrt((e3(3)^2 + 0.1^2)/2.), sqrt((e3(4)^2 + 0.1^2)/2.), sqrt((e3(5)^2 + 0.1^2)/2.)]
 ca7300_3u = ca7300_3.*[sqrt((e3(1)^2 + 0.1^2)/2.), sqrt((e3(2)^2 + 0.1^2)/2.), sqrt((e3(3)^2 + 0.5^2)/2.), sqrt((e3(4)^2 + 0.2^2)/2.), sqrt((e3(5)^2 + 0.1^2)/2.)] % 149d: Broad base not captured

 caIR_3 = [1.79e40, 1.15e40, 7.10e39, 2.66e38, 1.10e38] % 
 caIR_3l = caIR_3.*[sqrt((e3(1)^2 + 0.1^2)/2.), sqrt((e3(2)^2 + 0.1^2)/2.), sqrt((e3(3)^2 + 0.1^2)/2.), sqrt((e3(4)^2 + 0.1^2)/2.), sqrt((e3(5)^2 + 1^2)/2.)]
 caIR_3u = caIR_3.*[sqrt((e3(1)^2 + 0.1^2)/2.), sqrt((e3(2)^2 + 0.1^2)/2.), sqrt((e3(3)^2 + 0.1^2)/2.), sqrt((e3(4)^2 + 1^2)/2.), sqrt((e3(5)^2 + 0.2^2)/2.)]% 149 and 280d,  Broad base not captured

 oi5577_3 = [1.77e39, 1.40e39, 8.29e38, 0, 0] % Line not detected from 280 days
 oi5577_3l = oi5577_3.*[sqrt((e3(1)^2 + 0.1^2)/2.), sqrt((e3(2)^2 + 0.1^2)/2.), sqrt((e3(3)^2 + 0.1^2)/2.), sqrt((e3(4)^2 + 0.1^2)/2.), 0]
 oi5577_3u = oi5577_3.*[sqrt((e3(1)^2 + 0.1^2)/2.), sqrt((e3(2)^2 + 0.1^2)/2.), sqrt((e3(3)^2 + 0.1^2)/2.), sqrt((e3(4)^2 + 0.1^2)/2.), 0]

 oi6300_3 = [4.91e39, 5.49e39, 5.52e39, 1.69e39, 4.45e38]
 oi6300_3l = oi6300_3.*[sqrt((e3(1)^2 + 0.1^2)/2.), sqrt((e3(2)^2 + 0.1^2)/2.),  sqrt((e3(3)^2 + 0.1^2)/2.), sqrt((e3(4)^2 + 0.1^2)/2.), sqrt((e3(5)^2 + 0.2^2)/2.)]
 oi6300_3u = oi6300_3.*[sqrt((e3(1)^2 + 0.1^2)/2.), sqrt((e3(2)^2 + 0.1^2)/2.),  sqrt((e3(3)^2 + 0.1^2)/2.), sqrt((e3(4)^2 + 0.2^2)/2.), sqrt((e3(5)^2 + 0.4^2)/2.)]

 erroroimass_3l = sqrt( (oi6300_3l./oi6300_3).^2 + (1 - (9.6-1.3)^2/9.6^2)^2 + (1-2.08/2.66)^2 + (1-54/61)^2)  % Delta-L^2 + DeltaD2^2 + Deltaf_reddening^2 + deltaexp(22800/T)^2

 oi9260_3 = [2.41e39, 0, 1.25e39, 1.04e38, 0] % Not detected at 359d
 oi9260_3l = oi9260_3.*[sqrt((e3(1)^2 + 0.1^2)/2.), sqrt((e3(2)^2 + 0.1^2)/2.), sqrt((e3(3)^2 + 0.1^2)/2.), sqrt((e3(4)^2 + 0.1^2)/2.), 0]
 oi9260_3u = oi9260_3.*[sqrt((e3(1)^2 + 0.1^2)/2.), sqrt((e3(2)^2 + 0.1^2)/2.), sqrt((e3(3)^2 + 0.1^2)/2.), sqrt((e3(4)^2 + 0.1^2)/2.), 0]

 oi7774_3 = [2.92e39, 1.99e39, 1.07e39, 7.21e37, 0] % not detected at 359d
 oi7774_3l = oi7774_3.*[sqrt((e3(1)^2 + 0.1^2)/2.), sqrt((e3(2)^2 + 0.1^2)/2.), sqrt((e3(3)^2 + 0.1^2)/2.), sqrt((e3(4)^2 + 0.2^2)/2.), 0]
 oi7774_3u = oi7774_3.*[sqrt((e3(1)^2 + 0.1^2)/2.), sqrt((e3(2)^2 + 0.1^2)/2.), sqrt((e3(3)^2 + 0.1^2)/2.), sqrt((e3(4)^2 + 0.2^2)/2.), 0]

 mg4571_3 = [8.65e38, 7.49e38, 5.29e38, 4.23e38, 0] % N/A at 359d
 mg4571_3l = mg4571_3.*[sqrt((e3(1)^2 + 0.1^2)/2.), sqrt((e3(2)^2 + 0.1^2)/2.), sqrt((e3(3)^2 + 0.1^2)/2.), sqrt((e3(4)^2 + 0.2^2)/2.), 0]
 mg4571_3u = mg4571_3.*[sqrt((e3(1)^2 + 0.1^2)/2.), sqrt((e3(2)^2 + 0.1^2)/2.), sqrt((e3(3)^2 + 0.1^2)/2.), sqrt((e3(4)^2 + 0.2^2)/2.), 0]
 
 fe7155_3 = [0, 0, 0, 1.83e38, 5.18e37]% N/A 100d, 116d, 143d, 
 fe7155_3l = fe7155_3.*[0, 0, 0, 0.5, 0.5];
 fe7155_3u = fe7155_3.*[0, 0, 0, 0.5, 0.5];

% Read filters
fid = fopen('~/data/filters/mattias/3.6um.dat')
fgetl(fid)
spitzer3p6 = fscanf(fid,'%f',[2 Inf]);
fclose(fid)

fid = fopen('~/data/filters/mattias/4.5um.dat')
fgetl(fid)
spitzer4p5 = fscanf(fid,'%f',[2 Inf]);
fclose(fid)

fid = fopen('~/data/filters/mattias/K_2MASS.dat')
filterK = fscanf(fid,'%f',[2 Inf]);
fclose(fid)

fid = fopen('~/data/filters/mattias/H_2MASS.dat')
filterH = fscanf(fid,'%f',[2 Inf]);
fclose(fid)

for i = 1:Nmodels

  for j = 1:Nepochs(i)

    Ldust(i,j) = A(i,j,dustcol(i));  % Read dust luminosities TEMP

  end

end

%Ldust(:,:) = 0; % TEMP

Nwldust = 1000;
wldust = linspace(0.3e4,10e4,Nwldust);
Ldusttot = zeros(Nmodels,Ntimesmax);
dustflux = zeros(Nmodels,Ntimesmax,Nwldust);

% COMPUTE DUST SEDs :::::::::::::::::::::::::::::::::::::::::::

for i = 1:Nmodels

   for j = 1:Nepochs(i)  % For each epoch...

       if (Ldust(i,j) > 0)  % is there any dust in this model?
   
           areadust(i,j) = xdust(i)*4*pi*(Vdust(i)*1e5*A(i,j,2)*24*3600).^2;  % Define a surface area of the dust
 
           Tdust(i,j) = (Ldust(i,j)/(areadust(i,j)*5.67e-5))^(0.25);  % Black-body dust temperature 
							  						     
           dustflux(i,j,1:Nwldust) = pi*2*h*c^2./(wldust*1e-8).^5./(exp(h*c./(wldust*1e-8*k*Tdust(i,j)))-1.)*areadust(i,j)/DF/1e8;  % erg s-1 cm-2 A^-1 at observer
  
           for l = 2:length(wldust)  % INtegarte total luminosity

               Ldusttot(i,j) = Ldusttot(i,j) + dustflux(i,j,l)*(wldust(l)-wldust(l-1));

           end

       end

   end

end

% Compute contribution by dust to photometry
	
for i = 1:Nmodels

  for j = 1:Nepochs(i)

    integral3p6 = 0;
    normal3p6 = 0;
    integral4p5 = 0;
    normal4p5 = 0;
    integralK = 0;
    normalK = 0;
    integralH = 0;
    normalH = 0;
					
    for l = 2:length(spitzer3p6(1,:)) % For each wavelength in the filter...

        wl = spitzer3p6(1,l);

        [apa2,ind] = min(abs(wldust - wl));  % Find index in wldust vector closest to this wl

        integral3p6 = integral3p6 + dustflux(i,j,ind)*spitzer3p6(2,l)*(spitzer3p6(1,l)-spitzer3p6(1,l-1)); 
        
        normal3p6 = normal3p6 + spitzer3p6(2,l)*(spitzer3p6(1,l)-spitzer3p6(1,l-1));
         
    end

    for l = 2:length(spitzer4p5(1,:))

        wl = spitzer4p5(1,l);

        [apa2,ind] = min(abs(wldust - wl));
       
        integral4p5 = integral4p5 + dustflux(i,j,ind)*spitzer4p5(2,l)*(spitzer4p5(1,l)-spitzer4p5(1,l-1)); 
		
        normal4p5 = normal4p5 + spitzer4p5(2,l)*(spitzer4p5(1,l)-spitzer4p5(1,l-1));
        
    end

    for l = 2:length(filterK(1,:))  % FOr each filter point...
        
        wl = filterK(1,l)  % Current filter wavelength

        [apa2,ind] = min(abs(wldust - wl))     % Find index in flux vector for this wavelength
        
	integralK = integralK + dustflux(i,j,ind)*filterK(2,l)*(filterK(1,l)-filterK(1,l-1))  % integrate
	
        normalK = normalK + filterK(2,l)*(filterK(1,l)-filterK(1,l-1))  % the filter integral

    end

    for l = 2:length(filterH(1,:))  % FOr each filter point...
        
        wl = filterH(1,l)  % Current filter wavelength

        [apa2,ind] = min(abs(wldust - wl))     % Find index in flux vector for this wavelength
        
	integralH = integralH + dustflux(i,j,ind)*filterH(2,l)*(filterH(1,l)-filterH(1,l-1))  % integrate
	
        normalH = normalH + filterH(2,l)*(filterH(1,l)-filterH(1,l-1))  % the filter integral

    end


    dustfluxH(i,j) = integralH/normalH;
    dustfluxK(i,j) = integralK/normalK; 
    dustflux3p6(i,j) = integral3p6/normal3p6;  
    dustflux4p5(i,j) = integral4p5/normal4p5;    
    %magK(i,j) = -25.92 - 2.5*log10(dustfluxK(i,j));
    %mag3p6(i,j) = -27.94 - 2.5*log10(dustflux3p6(i,j));
    %mag4p5(i,j) = -28.93 - 2.5*log10(dustflux4p5(i,j));

  end

end

% Add contributions by molecules to magnitudes

for i = 1:Nmodels

  for j = 1:Nepochs(i)

    lumSiO(i,j) = A(i,j,molcoolSiOcol(i));
    lumCO(i,j) = A(i,j,molcoolCOcol(i));
    fluxSiO(i,j) = lumSiO(i,j)/DF;  % erg / s / cm2
    fluxCO(i,j) = lumCO(i,j)/DF;
    frac_fund_co(i,j) = min([1,0.5 + 0.5*(A(i,j,2)-100.)/300.]);  % Fraction of CO cooling done by fundamental band..from 1987A data of Bouchet Danziger 1993 : ~50% at 100 days, increasing linearly to 95-100% by 400 days, then flattens out at ~95%.
    frac_fund_SiO(i,j) = frac_fund_co(i,j);

    fluxS1(i,j) = FrefS1*10.^(-A(i,j,S1col(i))/2.5);
    fluxS2(i,j) = FrefS2*10.^(-A(i,j,S2col(i))/2.5);  % Get the
                                                      % model S2
                                                      % flux
                                                      % without any
                                                      % molecules
    fluxS1_withmol(i,j) = fluxS1(i,j)
    fluxS2_withmol(i,j) = fluxS2(i,j) + fluxCO(i,j)*frac_fund_co(i,j)*0.45/normal4p5 + fluxSiO(i,j)*(1-frac_fund_SiO(i,j))*0.38/normal4p5;
    
    fluxK(i,j) = FrefK*10.^(-A(i,j,Kcol(i))/2.5);
    fluxH(i,j) = FrefH*10.^(-A(i,j,Hcol(i))/2.5);
    fluxK_withmol(i,j) = fluxK(i,j) + fluxCO(i,j)*(1-frac_fund_co(i,j))*0.25/normalK    % Box-line profile from 2.25 to 2.45 my --> a quarter is captured (2.25-2.3 mu where the filter ends)
    S1_WITHMOL(i,j) = A(i,j,S1col(i));  % Molecules dont influence S1 band
    S2_WITHMOL(i,j) = 2.5*log10(FrefS2./fluxS2_withmol(i,j)); % TEMP int F*filter/ int filter = F*bar(filter)/int filter. bar(filter) = 0.45, CO fundamental band is like a downsloping triangle from 4.4 mu to 5.6 mu (wooden 1993) --> right half is outside band, which is 1/4 of the flux
    K_WITHMOL(i,j) = 2.5*log10(FrefK./fluxK_withmol(i,j));

  end

end


% Compute what K, S1 and S2 photometry is with dust


for i = 1:Nmodels

  for j = 1:Nepochs(i)

      %fluxS1_withmol= 10.^((-27.94-A(i,j,S1col(i)))/2.5);  % Fluxes without dust (but with mol)

      %fluxS2_withmol = 10.^((-28.93-S2_WITHMOL(i,j))/2.5);   % Flux without dust (but with mol)
      %%flux3 = 10.^((-25.92-A43(Kcol,ind))/2.5);
      %fluxK_withmol = 10.^((-25.92-K_WITHMOL(i,j))/2.5);  % Flux without dust (but with mol)

      S1_wdustandmol(i,j) = -27.94 - 2.5*log10(fluxS1_withmol(i,j) + dustflux3p6(i,j));
      S2_wdustandmol(i,j) = -28.93 - 2.5*log10(fluxS2_withmol(i,j) + dustflux4p5(i,j));
      K_wdustandmol(i,j) = -25.92 - 2.5*log10(fluxK_withmol(i,j) + dustfluxK(i,j));
      H_wdustandmol(i,j) = -24.86 - 2.5*log10(fluxH(i,j) + dustfluxH(i,j));

  end

end

figure(100), clf, hold on, box on % ::::::: MG I NIR LUMINOSITY:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

  % DATA
   ind = find(mgir_2 > 0 & times2 > 0.);
  h1=errorbar(times2(ind), mgir_2(ind)./L2(ind), mgir_2l(ind)./L2(ind), mgir_2u(ind)./L2(ind),'ro')
  %ind = find(mg4571_3 > 0 & times3 > 14xs0.);
  L3_1 = 1.06e42*(exp(-101/111.4) - exp(-101/8.8))*(m56ni_2008ax/0.075);
  L3_2 = 1.06e42*(exp(-130/111.4) - exp(-130/8.8))*(m56ni_2008ax/0.075);
  h2=errorbar([101 130], [8.23e38/L3_1 4.28e38/L3_2], [0.2*8.23e38/L3_1 0.4*4.28e38/L3_2], [0.3*8.23e38/L3_1 0.4*4.28e38/L3_2], 'd','Color',forestgreen)
  %mg4571_3l(ind)./L3(ind),
  %mg4571_3u(ind)./L3(ind),'d','Color',forestgreen)
  % L3 = 1.06e42*(exp(-times3/111.4) - exp(-times3/8.8))*(m56ni_2008ax/0.075);
  %ind = find(mg4571 > 0 & times1 > 140.);
  %h3=errorbar(times1(ind), mg4571(ind)./L1(ind), mg4571_l(ind)./L1(ind), mg4571_u(ind)./L1(ind),'bs')

  % MODELS

  clear style
  clear stylevec
  stylevec = {'--','--','--','--','--','-.','-.','-.','-.','-.',':',':',':',':',':'}
  colorvec = {'k', 'b', 'g', 'c', 'm',  'k', 'b','g', 'c', 'm', 'k','b','g','c','m'}
   
  for i = 1:Nmodels
   ind = find(A(i,:,2) >= 1 & A(i,:,2) <= modelend);  % Model lines become chaotic
                                  % before ~200 days (no clear Mg I
                                  % line)
   style = char(stylevec(i));
   color = char(colorvec(i));
   plot(A(i,ind,2), A(i,ind,mgircol(i))./Ldecay(i,ind), 'Linestyle',style,'Color',color)
  end

  ylim([0 0.0025])
  xlim([50 300])
  title('Mg I] 1.504 $\mu$m')
  M1 = {'2011dh','2008ax'}
  M = [M1,M2];
  hh=legend(M)
  set(hh,'box','off')
  xlabel('Time (days)')
  ylabel('$L_{\mbox{norm}}$')

uistack(h1,'top')
uistack(h2,'top')
%uistack(h3,'top')


figure(101), clf, hold on, box on % ::::::: MG I 4571 LUMINOSITY:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

  % DATA
  ind = find(mg4571_2 > 0 & times2 > 140.);
  h1=errorbar(times2(ind), mg4571_2(ind)./L2(ind), mg4571_2l(ind)./L2(ind), mg4571_2u(ind)./L2(ind),'ro')
  ind = find(mg4571_3 > 0 & times3 > 140.);
  h2=errorbar(times3(ind), mg4571_3(ind)./L3(ind), mg4571_3l(ind)./L3(ind), mg4571_3u(ind)./L3(ind),'d','Color',forestgreen)
  ind = find(mg4571 > 0 & times1 > 140.);
  h3=errorbar(times1(ind), mg4571(ind)./L1(ind), mg4571_l(ind)./L1(ind), mg4571_u(ind)./L1(ind),'bs')

  % MODELS

  clear style
  clear stylevec
  stylevec = {'--','--','--','--','--','-.','-.','-.','-.','-.',':',':',':',':',':'}
  colorvec = {'k', 'b', 'g', 'c', 'm',  'k', 'b','g', 'c', 'm', 'k','b','g','c','m'}
   
  for i = 1:Nmodels
   ind = find(A(i,:,2) >= 200 & A(i,:,2) <= modelend);  % Model lines become chaotic
                                  % before ~200 days (no clear Mg I
                                  % line)
   style = char(stylevec(i));
   color = char(colorvec(i));
   plot(A(i,ind,2), A(i,ind,Mgcol(i))./Ldecay(i,ind), 'Linestyle',style,'Color',color)
  end

  ylim([0 0.006])
  xlim([100 modelend+100])
  title('Mg I] $\lambda$4571')
  M1 = {'2011dh','2008ax','1993J'}
  M = [M1,M2];
  hh=legend(M)
  set(hh,'box','off')
  xlabel('Time (days)')
  ylabel('$L_{\mbox{norm}}$')

uistack(h1,'top')
uistack(h2,'top')
uistack(h3,'top')

figure(102), clf, hold on, box on  % ::::::::O I 5577::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

  ind = find(oi5577_2 > 0);
  h1=errorbar(times2(ind), oi5577_2(ind)./L2(ind), oi5577_2l(ind)./L2(ind), oi5577_2u(ind)./L2(ind),'ro')
  ind = find(oi5577_3 > 0);
  h2=errorbar(times3(ind), oi5577_3(ind)./L3(ind), oi5577_3l(ind)./L3(ind), oi5577_3u(ind)./L3(ind),'d','color',forestgreen)
  ind = find(oi5577 > 0);
  h3=errorbar(times1(ind), oi5577(ind)./L1(ind), oi5577_l(ind)./L1(ind), oi5577_u(ind)./L1(ind),'bs')
 	
  for i = 1:Nmodels
   ind = find(A(i,:,2) >= tminplot);   % Why am I cutting at 150 here?
   style = char(stylevec(i));
   color = char(colorvec(i));
   plot(A(i,ind,2), A(i,ind,o5577col(i))./Ldecay(i,ind), 'Linestyle',style,'Color',color)
  end

  title('[O I] $\lambda$5577')										
  xlabel('Time (days)')
  ylabel('$L_{\mbox{norm}}$')
  hh=legend(M)	
  set(hh,'box','off')		
  ylim([0 6e-3])
  xlim([50 400])

uistack(h1,'top')
uistack(h2,'top')
uistack(h3,'top')

figure(103), clf, hold on, box on % ::::::::::::::::::::::::::::::::::::::::::::::::::::

  ind = find(oi5577_2 > 0);
  h1=errorbar(times2(ind), oi5577_2(ind)./oi6300_2(ind), oi5577_2(ind)./oi6300_2(ind).*sqrt((oi5577_2l(ind)./oi5577_2(ind)).^2 + (oi6300_2l(ind)./oi6300_2(ind)).^2),  oi5577_2(ind)./oi6300_2(ind).*sqrt((oi5577_2u(ind)./oi5577_2(ind)).^2 + (oi6300_2u(ind)./oi6300_2(ind)).^2),'ro') % TEMP
  ind = find(oi5577_3 > 0);
  h2=errorbar(times3(ind), oi5577_3(ind)./oi6300_3(ind), oi5577_3(ind)./oi6300_3(ind).*sqrt((oi5577_3l(ind)./oi5577_3(ind)).^2 + (oi6300_3l(ind)./oi6300_3(ind)).^2), oi5577_3(ind)./oi6300_3(ind).*sqrt((oi5577_3u(ind)./oi5577_3(ind)).^2 + (oi6300_3u(ind)./oi6300_3(ind)).^2),'d','color',forestgreen)
  ind = find(oi5577 > 0);
  h3=errorbar(times1(ind), oi5577(ind)./oi6300(ind), oi5577(ind)./oi6300(ind).*sqrt((oi5577_l(ind)./oi5577(ind)).^2 + (oi6300_l(ind)./oi6300(ind)).^2) , oi5577(ind)./oi6300(ind).*sqrt((oi5577_u(ind)./oi5577(ind)).^2 + (oi6300_u(ind)./oi6300(ind)).^2) , 'bs')
 	
  for i = 1:Nmodels
   ind = find(A(i,:,2) >= tminplot); % Why 150 here before?
   style = char(stylevec(i));
   color = char(colorvec(i));
   plot(A(i,ind,2), A(i,ind,o5577col(i))./A(i,ind,Oicol(i)), 'Linestyle',style,'Color',color)
  end

  title('O I $\lambda$5577 / [O I] $\lambda \lambda$6300, 6364')
  ylim([0 1])
  xlim([50 400])
  ylabel('Ratio')
  xlabel('Time (days)')
  hh=legend(M)
  set(hh,'box','off')
   uistack(h1,'top')
uistack(h2,'top')
uistack(h3,'top')

figure(104), clf, hold on, box on % ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

 % Data
 ind = find(oi6300_2 > 0);
 h1=errorbar(times2(ind), oi6300_2(ind)./L2(ind), oi6300_2l(ind)./L2(ind), oi6300_2u(ind)./L2(ind),'ro')
 ind = find(oi6300_3 > 0);
 h2=errorbar(times3(ind), oi6300_3(ind)./L3(ind), oi6300_3l(ind)./L3(ind), oi6300_3u(ind)./L3(ind),'d','Color',forestgreen)
 ind = find(oi6300 > 0);
 h3=errorbar(times1(ind), oi6300(ind)./L1(ind), oi6300_l(ind)./L1(ind), oi6300_u(ind)./L1(ind),'s')

  title('[O I] $\lambda \lambda$6300, 6364')

  for i = 1:Nmodels
   ind = find(A(i,:,2) >= tminplot & A(i,:,2) <= modelend);
   style = char(stylevec(i));
   color = char(colorvec(i));
   plot(A(i,ind,2), A(i,ind,Oicol(i))./Ldecay(i,ind), 'Linestyle',style,'Color',color)
  end

 hh=legend(M)
 set(hh,'box','off')
 xlabel('Time (days)')
 ylabel('$L_{\mbox{norm}}$')
 set(gca,'Xminortick','on')
 set(gca,'Yminortick','on')
 xlim([50 modelend+100])
  uistack(h1,'top')
uistack(h2,'top')
uistack(h3,'top')

figure(1004), clf, hold on, box on % ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

 % Data
 ind = find(oi6300_2 > 0);
 errorbar(times2(ind), oi6300_2(ind)./L2(ind), oi6300_2l(ind)./L2(ind), oi6300_2u(ind)./L2(ind),'ro')
 ind = find(oi6300_3 > 0);
 errorbar(times3(ind), oi6300_3(ind)./L3(ind), oi6300_3l(ind)./L3(ind), oi6300_3u(ind)./L3(ind),'d','Color',forestgreen)
 ind = find(oi6300 > 0);
 errorbar(times1(ind), oi6300(ind)./L1(ind), oi6300_l(ind)./L1(ind), oi6300_u(ind)./L1(ind),'s')

  title('[O I] $\lambda \lambda$6300, 6364')

  for i = 1:Nmodels
   ind = find(A(i,:,2) >= tminplot & A(i,:,2) <= modelend);
   style = char(stylevec(i));
   color = char(colorvec(i));
   if (cell2mat(M2(i)) == '12C')
       i
       cell2mat(M2(i))

       plot(A(i,ind,2), A(i,ind,Oicol(i))./Ldecay(i,ind), 'Linestyle',style,'Color',color)

    end
       if (cell2mat(M2(i)) == '13F')
       i
       cell2mat(M2(i))

       plot(A(i,ind,2), A(i,ind,Oicol(i))./Ldecay(i,ind), 'Linestyle',style,'Color',color)

    end
    if (cell2mat(M2(i)) == '17A')
       i
       cell2mat(M2(i))

       plot(A(i,ind,2), A(i,ind,Oicol(i))./Ldecay(i,ind), 'Linestyle',style,'Color',color)

    end
 
  end

  %M1 = {'2011dh','2008ax','1993J'}
  Mspec = [{'2011dh'},{'2008ax'},{'1993J'}];
  text(510,0.013,'17 M$_\odot$','Fontsize',20)
  text(510,0.006,'13 M$_\odot$','Fontsize',20)
  text(510,0.0025,'12 M$_\odot$','Fontsize',20)
 
  legend(Mspec) 
 xlabel('Time (days)')
 ylabel('$L_{\mbox{norm}}$')
 set(gca,'Xminortick','on')
 set(gca,'Yminortick','on')
 xlim([50 modelend+100])

    
figure(105), clf, hold on, box on % :::::::Fe II 7155 ::::::::::::::::::::::::::::

 % DATA
 ind = find(fe7155_2 > 0);
 h1=errorbar(times2(ind), fe7155_2(ind)./L2(ind), fe7155_2l(ind)./L2(ind), fe7155_2u(ind)./L2(ind),'ro')
 ind = find(fe7155_3 > 0);
 h2=errorbar(times3(ind), fe7155_3(ind)./L3(ind), fe7155_3l(ind)./L2(ind), fe7155_3u(ind)./L3(ind),'d','color',forestgreen)
 ind = find(fe7155 > 0);
 h3=errorbar(times1(ind), fe7155(ind)./L1(ind), fe7155_l(ind)./L1(ind), fe7155_u(ind)./L1(ind),'bs')

 title('[Fe II] $\lambda$7155')

  for i = 1:Nmodels
   ind = find(A(i,:,2) > tminplot & A(i,:,2) <= modelend);
   style = char(stylevec(i));
   color = char(colorvec(i));
   plot(A(i,ind,2), A(i,ind,Fecol(i))./Ldecay(i,ind), 'Linestyle',style,'Color',color)
  end	
 
 ylim([0 0.004])
 xlim([50 modelend+100])
 hh=legend(M)
 set(hh,'box','off')
 xlabel('Time (days)')
 ylabel('$L_{\mbox{norm}}$')

uistack(h1,'top')
uistack(h2,'top')
uistack(h3,'top')


figure(106), clf, hold on, box on  % :::::::::::::::CA IR::::::::::::::::::::::

 % DATA
 ind = find(caIR_2 > 0);
 h1=errorbar(times2(ind), caIR_2(ind)./L2(ind), caIR_2l(ind)./L2(ind), caIR_2u(ind)./L2(ind),'ro')
 ind = find(caIR_3 > 0);
 h2=errorbar(times3(ind), caIR_3(ind)./L3(ind), caIR_3l(ind)./L3(ind), caIR_3u(ind)./L3(ind),'d','color',forestgreen)
 ind = find(caIR > 0);
 h3=errorbar(times1(ind), caIR(ind)./L1(ind), caIR_l(ind)./L1(ind), caIR_u(ind)./L1(ind),'bs')

 for i = 1:Nmodels
   ind = find(A(i,:,2) >= tminplot & A(i,:,2) <= modelend);  % CARE was 150 here before
   style = char(stylevec(i));
   color = char(colorvec(i));
   plot(A(i,ind,2), A(i,ind,Ca8500col(i))./Ldecay(i,ind), 'Linestyle',style,'Color',color)
 end	

 title('Ca II IR')
 ylim([0 0.03])
 xlabel('Time (days)')
 ylabel('$L_{\mbox{norm}}$')
 xlim([50 modelend+100])
 hh=legend(M)
 set(hh,'box','off')

 uistack(h1,'top')
uistack(h2,'top')
uistack(h3,'top')

figure(109), clf, hold on  % :::::::::::::::::::::::::::::::::::::

 ind = find(oi9260 > 0);
errorbar(times1(ind), oi9260(ind)./L1(ind), oi9260_l(ind)./L1(ind), oi9260_u(ind)./L1(ind),'o')
   ind = find(oi9260_2 > 0);
errorbar(times2(ind), oi9260_2(ind)./L2(ind), oi9260_2l(ind)./L2(ind), oi9260_2u(ind)./L2(ind),'ro')
  ind = find(oi9260_3 > 0);
errorbar(times3(ind), oi9260_3(ind)./L3(ind), oi9260_3l(ind)./L3(ind), oi9260_3u(ind)./L3(ind),'kd')
  title('OI 9260')
legend('1993J','2011dh')

figure(107), clf, hold on, box on % ::::::::Ca 7300:::::::::::::::::::::::::::

  % DATA
 ind = find(ca7300_2 > 0);
 h1=errorbar(times2(ind), ca7300_2(ind)./L2(ind), ca7300_2l(ind)./L2(ind), ca7300_2u(ind)./L2(ind),'ro')
 ind = find(ca7300_3 > 0);
 h2=errorbar(times3(ind), ca7300_3(ind)./L3(ind), ca7300_3l(ind)./L3(ind), ca7300_3u(ind)./L3(ind),'d','color',forestgreen)
 ind = find(ca7300 > 0);
 h3=errorbar(times1(ind), ca7300(ind)./L1(ind), ca7300_l(ind)./L1(ind), ca7300_u(ind)./L1(ind),'bs')
  
 for i = 1:Nmodels
   ind = find(A(i,:,2) >= tminplot & A(i,:,2) <= modelend); % TEMP why 150
   style = char(stylevec(i));
   color = char(colorvec(i));
   plot(A(i,ind,2), A(i,ind,Ca7300col(i))./Ldecay(i,ind), 'Linestyle',style,'Color',color)
 end	

 title('[Ca II] $\lambda \lambda$7291, 7323')							 
 hh=legend(M)
 set(hh,'box','off')
 xlabel('Time (days)')
 ylabel('$L_{\mbox{norm}}$')
 set(gca,'Xminortick','on')
 xlim([50 modelend+100])

   uistack(h1,'top')
uistack(h2,'top')
uistack(h3,'top')

figure(108), clf, hold on, box on  % MG / O ratio :::::::::::::::::::::::::::::::::

 % Data
 ind = find(oi6300_2 > 0 & mg4571_2 > 0);
 errorup = sqrt(1./oi6300_2(ind).^2.*mg4571_2u(ind).^2  + mg4571_2(ind).^2./oi6300_2(ind).^4.*oi6300_2u(ind).^2);
 errordown = sqrt(1./oi6300_2(ind).^2.*mg4571_2l(ind).^2  + mg4571_2(ind).^2./oi6300_2(ind).^4.*oi6300_2l(ind).^2);
 h1=errorbar(times2(ind), mg4571_2(ind)./oi6300_2(ind), errorup, errordown,'ro')
 ind = find(oi6300_3 > 0 & mg4571_3 > 0 & times3 > 150);
 errorup = sqrt(1./oi6300_3(ind).^2.*mg4571_3u(ind).^2  + mg4571_3(ind).^2./oi6300_3(ind).^4.*oi6300_3u(ind).^2);
 errordown = sqrt(1./oi6300_3(ind).^2.*mg4571_3l(ind).^2  + mg4571_3(ind).^2./oi6300_3(ind).^4.*oi6300_3l(ind).^2);
 h2=errorbar(times3(ind), mg4571_3(ind)./oi6300_3(ind), errordown, errorup,'d','Color',forestgreen)
 ind = find(oi6300 > 0 & mg4571 > 0);
 errorup = sqrt(1./oi6300(ind).^2.*mg4571_u(ind).^2  + mg4571(ind).^2./oi6300(ind).^4.*oi6300_u(ind).^2);
 errordown = sqrt(1./oi6300(ind).^2.*mg4571_l(ind).^2  + mg4571(ind).^2./oi6300(ind).^4.*oi6300_l(ind).^2);
 h3=errorbar(times1(ind), mg4571(ind)./oi6300(ind), errordown, errorup,'s')

 for i = 1:Nmodels
   ind = find(A(i,:,2) >= 200. & A(i,:,2) <= modelend); % Mg I 4571
                                                       % is not
                                                       % well
                                                       % defined in
                                                       % models
                                                       % before 200d
   style = char(stylevec(i));
   color = char(colorvec(i));
   plot(A(i,ind,2), A(i,ind,Mgcol(i))./A(i,ind,Oicol(i)), 'Linestyle',style,'Color',color)
  end

 title('Mg I]$\lambda$ 4571 / [O I] $\lambda \lambda$ 6300, 6364')
 hh=legend(M,'Location','Northwest')
 set(hh,'box','off')
 xlabel('Time (days)')
 ylabel('$L_{\mbox{norm}}$')
 set(gca,'Xminortick','on')
 set(gca,'Yminortick','on')
 ylim([0 0.5])
 xlim([50 modelend+100])

fid = fopen('/Users/anders/projects/SN2011dh/data/phot/sn2011dh-phot-scorr-late.dat')

%  fgetl(fid)

PDATALATE_cell = textscan(fid,'%f %f %f %f %f %f %f %f %f %f %f %f %f %*s %*s','headerlines',1)
PDATALATE = cell2mat(PDATALATE_cell)';

% COMBINE EARLY AND LATE DATA

l1 = length(PDATA(1,:));
l2 = length(PDATALATE(1,:));
dd = l1 + l2;
PDATA(1,1:dd) = [PDATA(1,1:l1) PDATALATE(1,:)]; % time
for i = 2:7
  PDATA(i,1:dd) = [PDATA(i,1:l1) 999*ones(1,l2)];
end
PDATA(8,1:dd) = [PDATA(8,1:l1) PDATALATE(2,:)]; % U
PDATA(9,1:dd) = [PDATA(9,1:l1) PDATALATE(3,:)];
PDATA(10,1:dd) = [PDATA(10,1:l1) PDATALATE(4,:)]; %B
PDATA(11,1:dd) = [PDATA(11,1:l1) PDATALATE(5,:)]
PDATA(12,1:dd) = [PDATA(12,1:l1) PDATALATE(6,:)]; % V
PDATA(13,1:dd) = [PDATA(13,1:l1) PDATALATE(7,:)]
PDATA(14,1:dd) = [PDATA(14,1:l1) PDATALATE(10,:)]; % R
PDATA(15,1:dd) = [PDATA(15,1:l1) PDATALATE(11,:)]
PDATA(16,1:dd) = [PDATA(16,1:l1) PDATALATE(12,:)]; % I
PDATA(17,1:dd) = [PDATA(17,1:l1) PDATALATE(13,:)]
for i = 18:21
  PDATA(i,1:dd) = [PDATA(i,1:l1) 999*ones(1,l2)];
end
PDATA(22,1:dd) = [PDATA(22,1:l1) PDATALATE(8,:)]; % r
PDATA(23,1:dd) = [PDATA(23,1:l1) PDATALATE(9,:)];
for i = 24:37
  PDATA(i,1:dd) = [PDATA(i,1:l1) 999*ones(1,l2)];
end

%  fclose(fid)

M11 = {'2011dh'}
Ms = [M11,M2];

 uistack(h1,'top')
uistack(h2,'top')
uistack(h3,'top')

figure(110), clf, hold on, box on % ---------U BAND ----------------

  % DATA
  ind = find(PDATA(8,:) < 100);
  timesU = PDATA(1,ind)-JDE;
  dataU = PDATA(8,ind);
  errorbar(timesU, dataU-timesU/102.,PDATA(9,ind),'rd')

 % MODEL
 for i = 1:Nmodels
   ind = find(A(i,:,2) > 100 & A(i,:,2) <= modelend);
   style = char(stylevec(i));
   color = char(colorvec(i));
   plot(A(i,ind,2), A(i,ind,Ucol(i))-A(i,ind,2)/102., 'Linestyle',style,'Color',color)
 end	

 xlabel('Time (days)')
 ylabel('U - t/102^d')
 title('U')
 set(gca,'Ydir','Reverse')
 set(gca,'Ygrid','on')
 set(gca,'Xgrid','on')
 ylim([13 19])
 xlim([100 modelend+100])
 legend(Ms)

figure(111), clf, hold on, box on % --------B BAND-----------------

 ind = find(PDATA(10,:) < 100);
 timesB = PDATA(1,ind)-JDE;
 dataB = PDATA(10,ind);
 errorbar(timesB, dataB-timesB/102.,PDATA(11,ind),'rd')
 %ind = find(PDATALATE(4,:) < 100);
 %timesB2 = PDATALATE(1,ind)-JDE;
 %dataB2 = PDATALATE(4,ind);
 %errorbar(timesB2, dataB2-timesB2/102.,PDATALATE(5,ind),'d')

 for i = 1:Nmodels
   ind = find(A(i,:,2) > 100 & A(i,:,2) <= modelend);
   style = char(stylevec(i));
   color = char(colorvec(i));
   plot(A(i,ind,2), A(i,ind,Bcol(i))-A(i,ind,2)/102., 'Linestyle',style,'Color',color)
 end

 xlabel('Time (days)')
 ylabel('B - t/102^d')
 title('B')
 set(gca,'Ydir','Reverse')
 set(gca,'Ygrid','on')
 set(gca,'Xgrid','on')
 ylim([13 19])
 xlim([100 modelend+100])
 legend(Ms)

figure(112), clf, hold on, box on % ----------V BAND ------------------------

 % DATA
 ind = find(PDATA(12,:) < 100);
 timesV = PDATA(1,ind)-JDE;
 dataV = PDATA(12,ind);
 errorbar(timesV, dataV-timesV/102.,PDATA(13,ind),'rd')
 %ind = find(PDATALATE(6,:) < 100);
 %timesV2 = PDATALATE(1,ind)-JDE;
 %dataV2 = PDATALATE(6,ind);
 %errorbar(timesV2, dataV2-timesV2/102.,PDATALATE(7,ind),'d')

 % MODELS
 for i = 1:Nmodels
   ind = find(A(i,:,2) > 0. & A(i,:,2) <= modelend);
   style = char(stylevec(i));
   color = char(colorvec(i));
   plot(A(i,ind,2), A(i,ind,Vcol(i))-A(i,ind,2)/102., 'Linestyle',style,'Color',color)
 end
 
 xlabel('Time (days)')
 ylabel('V - t/102^d')
 title('V')
 set(gca,'Ydir','Reverse')
 set(gca,'Ygrid','on')
 set(gca,'Xgrid','on')
 ylim([12 18])
 xlim([100-20 modelend+100])
 legend(Ms)

figure(113), clf, hold on, box on  % ----------r-BAND----------------

 % DATA
 ind = find(PDATA(22,:) < 100);
 timesr_s = PDATA(1,ind)-JDE;
 datar_s = PDATA(22,ind);
 errorbar(timesr_s, datar_s-timesr_s/102.,PDATA(23,ind), 'rd')
 %ind = find(PDATALATE(8,:) < 100);
 %timesr2_s = PDATALATE(1,ind)-JDE;
 %datar2_s = PDATALATE(8,ind);
 %errorbar(timesr2_s, datar2_s-timesr2_s/102.,PDATALATE(9,ind),'d')
 %ind = find(A43(2,:) >= 1.);
  ind = find(PDATA(14,:) < 100);
 timesR = PDATA(1,ind)-JDE;
 dataR = PDATA(14,ind);
 errorbar(timesR, dataR-timesR/102.,PDATA(15,ind), 'gd')

 xlabel('Time (days)')
 ylabel('r - t/102^d')
 title('Sloan r')
 set(gca,'Ydir','Reverse')
 set(gca,'Ygrid','on')
 set(gca,'Xgrid','on')
 ylim([12 18])
 xlim([0 800])

figure(114), clf, hold on, box on  % ----------R BAND------------------------

 % DATA
 ind = find(PDATA(14,:) < 100);
 timesR = PDATA(1,ind)-JDE;
 dataR = PDATA(14,ind);
 errorbar(timesR, dataR-timesR/102.,PDATA(15,ind), 'rd')
 %ind = find(PDATALATE(10,:) < 100);
 %timesR2 = PDATALATE(1,ind)-JDE;
 %dataR2 = PDATALATE(10,ind);
 %errorbar(timesR2, dataR2-timesR2/102.,PDATALATE(11,ind),'d')

 % MODELS
 for i = 1:Nmodels
   ind = find(A(i,:,2) > 0. & A(i,:,2) <= modelend);
   style = char(stylevec(i));
   color = char(colorvec(i));
   plot(A(i,ind,2), A(i,ind,Rcol(i))-A(i,ind,2)/102., 'Linestyle',style,'Color',color)
 end

 xlabel('Time (days)')
 ylabel('R - t/102 d')
 title('R')
 set(gca,'Ydir','Reverse')
 set(gca,'Ygrid','on')
 set(gca,'Xgrid','on')
 ylim([12 18])
 xlim([100 modelend+100])
 legend(Ms)

figure(115), clf, hold on, box on  % --------I BAND-------------------

  % DATA
 ind = find(PDATA(16,:) < 100);
 timesI = PDATA(1,ind)-JDE;
 dataI = PDATA(16,ind);
 errorbar(timesI, dataI-timesI/102.,PDATA(17,ind),'rd')
 %ind = find(PDATALATE(12,:) < 100);
 %timesI2 = PDATALATE(1,ind)-JDE;
 %dataI2 = PDATALATE(12,ind);
 %errorbar(timesI2, dataI2-timesI2/102.,PDATALATE(13,ind),'d')

 % MODELS
 for i = 1:Nmodels
   ind = find(A(i,:,2) > 0. & A(i,:,2) <= modelend);
   style = char(stylevec(i));
   color = char(colorvec(i));
   plot(A(i,ind,2), A(i,ind,Icol(i))-A(i,ind,2)/102., 'Linestyle',style,'Color',color)
 end

 xlabel('Time (days)')
 ylabel('I - t/102d')
 title('I')
 set(gca,'Ydir','Reverse')
 set(gca,'Ygrid','on')
 set(gca,'Xgrid','on')
 ylim([12 18])
 xlim([100 modelend+100])
 legend(Ms)

figure(116), clf, hold on, box on % -----------J BAND ------------------

 % DATA
 ind = find(PDATA(28,:) < 100);
 timesJ = PDATA(1,ind)-JDE;
 dataJ = PDATA(28,ind);
 errorbar(timesJ, dataJ-timesJ/102.,PDATA(29,ind),'rd')

 % MODELS
  for i = 1:Nmodels
   ind = find(A(i,:,2) > 0. & A(i,:,2) <= modelend);
   style = char(stylevec(i));
   color = char(colorvec(i));
   plot(A(i,ind,2), A(i,ind,Jcol(i))-A(i,ind,2)/102., 'Linestyle',style,'Color',color)
 end

 xlabel('Time (days)')
 ylabel('J - t/102d')
 title('J')
 set(gca,'Ygrid','on')
 set(gca,'Xgrid','on')
 set(gca,'Ydir','Reverse')
 ylim([11 17])
 xlim([100 modelend+100])
 legend(Ms)

figure(117), clf, hold on, box on % ---------H BAND -----------

 % DATA
 ind = find(PDATA(30,:) < 100);
 timesH = PDATA(1,ind)-JDE;
 dataH = PDATA(30,ind);
 errorbar(timesH, dataH-timesH/102.,PDATA(31,ind),'rd')
 
 % MODEL
 for i = 1:Nmodels
   ind = find(A(i,:,2) > 0. & A(i,:,2) <= modelend);
   style = char(stylevec(i));
   color = char(colorvec(i));
   % plot(A(i,ind,2), A(i,ind,Hcol(i))-A(i,ind,2)/102., 'Linestyle',style,'Color',color)
   plot(A(i,ind,2), H_wdustandmol(i,ind)-A(i,ind,2)/102., 'Linestyle',style,'Color',color)
 end

 xlabel('Time (days)')
 ylabel('H - t/102d')
 title('H')
 set(gca,'Ydir','Reverse')
 set(gca,'Xgrid','on')
 set(gca,'Ygrid','on')
 ylim([11 17])
 xlim([100 modelend+100])
 legend(Ms)

figure(118), clf, hold on, box on % ----------K BAND -----------------

 % DATA
 ind = find(PDATA(32,:) < 100);
 timesK = PDATA(1,ind)-JDE;
 dataK = PDATA(32,ind);
 errorbar(timesK, dataK-timesK/102.,PDATA(33,ind),'rd')

 % MODEL
 for i = 1:Nmodels
   ind = find(A(i,:,2) > 0. & A(i,:,2) <= modelend);
   style = char(stylevec(i));
   color = char(colorvec(i));
   %plot(A(i,ind,2), A(i,ind,Kcol(i))-A(i,ind,2)/102.,'LineStyle',style','Color',color)
   %'Linestyle',style,'Color',color)
    plot(A(i,ind,2), K_wdustandmol(i,ind)-A(i,ind,2)/102., 'Linestyle',style,'Color',color)
 end

 xlabel('Time (days)')
 ylabel('K - t/102^d')
 title('K (w dust and mol)')
 set(gca,'Ydir','Reverse')
 set(gca,'Xgrid','on')
 set(gca,'Ygrid','on')
 ylim([11 17])
 xlim([100 modelend+100])
 legend(Ms)



figure(119), clf, hold on, box on  % ----------------------S1 BAND----------------------------

  % DATA
  errorbar(timesS1, dataS1-timesS1/102.,errorS1,'rd')

 % MODEL
 %for i = 1:Nmodels
 %  ind = find(A(i,:,2) > 0.);
 %  style = char(stylevec(i));
 %  color = char(colorvec(i));
 %  plot(A(i,ind,2), A(i,ind,S1col(i))-A(i,ind,2)/102., 'Linestyle',style,'Color',color)
 %end

 for i = 1:Nmodels
   ind = find(A(i,:,2) > 0. & A(i,:,2) <= modelend);
   style = char(stylevec(i));
   color = char(colorvec(i));
   plot(A(i,ind,2), S1_wdustandmol(i,ind)-A(i,ind,2)/102., 'Linestyle',style,'Color',color)
 end
 

 xlabel('Time (days)')
 ylabel('Spitzer 3.6 \mum - t/102d')
 title('Spitzer 3.6 \mum')
 set(gca,'Ydir','Reverse')
 set(gca,'Ygrid','on')
 set(gca,'Xgrid','on')
 ylim([11 17])
 xlim([100 modelend+100])
 legend(Ms)


figure(120), clf, hold on, box on  % ----------------------S2 BAND----------------------------

  % DATA
  errorbar(timesS2, dataS2-timesS2/102.,errorS2,'rd')

 % MODEL
 %for i = 1:Nmodels
 %  ind = find(A(i,:,2) > 0.);
 %  style = char(stylevec(i));
 %  color = char(colorvec(i));
 %  plot(A(i,ind,2), A(i,ind,S2col(i))-A(i,ind,2)/102., 'Linestyle',style,'Color',color)
 %end

 for i = 1:Nmodels
   ind = find(A(i,:,2) > 0. & A(i,:,2) <= modelend);
   style = char(stylevec(i));
   color = char(colorvec(i));
   plot(A(i,ind,2), S2_wdustandmol(i,ind)-A(i,ind,2)/102.,'Linestyle',style,'Color',color)
   % 'Linestyle',style,'Color',color)
   %plot(A(i,ind,2), A(i,ind,S2col(i))-A(i,ind,2)/102., 'Linestyle',style,'Color',color)
 end
 

 xlabel('Time (days)')
 ylabel('Spitzer 4.5 \mum - t/102^d')
 title('Spitzer 4.5 \mum')
 set(gca,'Ydir','Reverse')
 set(gca,'Ygrid','on')
 set(gca,'Xgrid','on')
 ylim([8 15])
 xlim([100-20 modelend+100])
 legend(Ms,'Location','Northeast')



figure(121), clf, hold on, box on  % ------SPITZER 3.6 W AND WITHOUT DUST--------------------------------------------

  % DATA
  errorbar(timesS1, dataS1-timesS1/102.,errorS1,'rd')

  % MODEL
  plot(A(main,1:Nepochs(main),2), A(main,1:Nepochs(main),S1col(i))-A(main,1:Nepochs(main),2)/102., 'Linestyle',':','Color','k')
  plot(A(main,1:Nepochs(main),2), S1_WITHMOL(main,1:Nepochs(main))-A(main,1:Nepochs(main),2)/102., 'Linestyle','-','Color','k')
  plot(A(main,1:Nepochs(main),2), S1_wdustandmol(main,1:Nepochs(main))-A(main,1:Nepochs(main),2)/102,'r--')
 
  xlabel('Time (days)')
  ylabel('Spitzer 3.6 \mum - t/102^d')
  title('Spitzer 3.6 \mum')
  set(gca,'Ydir','Reverse')
  set(gca,'Ygrid','on')
  set(gca,'Xgrid','on')
  ylim([10 16])
  xlim([0 800])
  MM = [{'SN2011dh'},strcat(M2(main),{' atomic'}), strcat(M2(main),{' atomic + mol'}), strcat(M2(main),{' atomic + mol + dust'})];
  legend(MM)

figure(122), clf, hold on, box on  % ------SPITZER 4.5 W AND WITHOUT DUST--------------------------------------------

  % DATA
  errorbar(timesS2, dataS2-timesS2/102.,errorS2,'rd')

  % Model
  plot(A(main,1:Nepochs(main),2), A(main,1:Nepochs(main),S2col(i))-A(main,1:Nepochs(main),2)/102., 'Linestyle',':','Color','k')
  plot(A(main,1:Nepochs(main),2), S2_WITHMOL(main,1:Nepochs(main))-A(main,1:Nepochs(main),2)/102., 'Linestyle','-','Color','k')
  plot(A(main,1:Nepochs(main),2), S2_wdustandmol(main,1:Nepochs(main))-A(main,1:Nepochs(main),2)/102,'r--')
 
 xlabel('Time (days)')
 ylabel('Spitzer 4.5 \mum - t/102^d')
 title('Spitzer 4.5 \mum')
 set(gca,'Ydir','Reverse')
 set(gca,'Ygrid','on')
 set(gca,'Xgrid','on')
 ylim([10 16])
 xlim([0 800])
 legend(MM,'Location','Southeast')

% -----------------------------

% MAKE BOLOMETRIC LIGHT CURVES -----------------------

FrefS1 = 6.50e-12;  % 
FrefS2 = 2.66e-12;  

tinterp = linspace(50,467);  % UDATA exists up to 383 d, B to 467
                             % d (+2 late), V 467 + 3 late, R to
                             % 467 d (no late), I to 441 d (+1
                             % late). Uband extrapolation looks ok
                             % (nothing weird going on) --> UBVRI
                             % LC should be reliable up to ~441 (or 467d)
tinterplate = linspace(350,640);

ind = find(timesU > 40);
Uinterp = interp1(timesU(ind), dataU(ind), tinterp,'linear'); % The
                                                              % interpolation
                                                              % gives
                                                              % NaN
                                                              % for
                                                              % times
                                                              % outside range
% Extrapolate between last point (383d) and interpolation end (467d)
indlast = length(dataU); % last point with data
ind = find(tinterp > timesU(indlast));
Uinterp(ind) = dataU(indlast) + (tinterp(ind) - timesU(indlast))*(dataU(indlast) - dataU(indlast-1))/(timesU(indlast)-timesU(indlast-1));

ind = find(timesB > 40);
Binterp = interp1(timesB(ind), dataB(ind), tinterp,'linear');
% Data goes to end of tinterp, no extrapolation needed TEMP do better
%ind = find(timesB > tinterplate(1));
%Binterplate = interp1(timesB(ind), dataB(ind), tinterplate,'linear');

ind = find(timesV > 40);
Vinterp = interp1(timesV(ind), dataV(ind), tinterp,'linear');
% Data goes to end of tinterp, no extrapolation needed TEMP do better
%ind = find(timesV > tinterplate(1));
%Vinterplate = interp1(timesV(ind), dataV(ind), tinterplate,'linear');

ind = find(timesR > 40);
Rinterp = interp1(timesR(ind), dataR(ind), tinterp,'linear');
% Data goes to end of tinterp, no extrapolation needed TEMP do better
%ind = find(timesr_s > tinterplate(1));
%rinterplate = interp1(timesr_s(ind), datar_s(ind), tinterplate,'linear');

ind = find(timesI > 40);
Iinterp = interp1(timesI(ind), dataI(ind), tinterp,'linear');
%ind = find(timesI > tinterplate(1));
%Iinterplate = interp1(timesI(ind), dataI(ind),
%tinterplate,'linear');
% DATa ends at 441 days, extrapolate to 467 days
indlast = length(dataI); % last point with data
ind = find(tinterp > timesI(indlast));
Iinterp(ind) = dataI(indlast) + (tinterp(ind) - timesI(indlast))*(dataI(indlast) - dataI(indlast-1))/(timesI(indlast)-timesI(indlast-1));

ind = find(timesJ > 40);
Jinterp = interp1(timesJ(ind), dataJ(ind), tinterp,'linear');
% No data after 381.48 days : extrapolate
indlast = length(dataJ); % last point with data
ind = find(tinterp > timesJ(indlast));
Jinterp(ind) = dataJ(indlast) + (tinterp(ind) - timesJ(indlast))*(dataJ(indlast) - dataJ(indlast-1))/(timesJ(indlast)-timesJ(indlast-1));

ind = find(timesH > 40);
Hinterp = interp1(timesH, dataH, tinterp,'linear');
% No data after 381.48 days : extrapolate
indlast = length(dataH); % last point with data
ind = find(tinterp > timesH(indlast));
Hinterp(ind) = dataH(indlast) + (tinterp(ind) - timesH(indlast))*(dataH(indlast) - dataH(indlast-1))/(timesH(indlast)-timesH(indlast-1));

ind = find(timesK > 40);
Kinterp = interp1(timesK, dataK, tinterp,'linear');
% No data after 381.48 days : extrapolate
indlast = length(dataK); % last point with data
ind = find(tinterp > timesK(indlast));
Kinterp(ind) = dataK(indlast) + (tinterp(ind) - timesK(indlast))*(dataK(indlast) - dataK(indlast-1))/(timesK(indlast)-timesK(indlast-1));

ind = find(timesS1 > 40);
S1interp = interp1(timesS1, dataS1, tinterp,'linear')

ind = find(timesS2 > 40);
S2interp = interp1(timesS2, dataS2, tinterp,'linear')

Uflux_obs = FrefU*10.^-(Uinterp/2.5);
Bflux_obs = FrefB*10.^-(Binterp/2.5);
Vflux_obs = FrefV*10.^-(Vinterp/2.5);
Rflux_obs = FrefR*10.^-(Rinterp/2.5);
Iflux_obs = FrefI*10.^-(Iinterp/2.5);
Jflux_obs = 10.^-((Jinterp+23.76)/2.5);
Hflux_obs = 10.^-((Hinterp+24.86)/2.5);
Kflux_obs = 10.^-((Kinterp+25.92)/2.5);
S1flux_obs = FrefS1*10.^-(S1interp/2.5);
S2flux_obs = FrefS2*10.^-(S2interp/2.5);
%Uflux_obs_late = FrefU*10.^-(Uinterplate/2.5);
%Bflux_obs_late = FrefB*10.^-(Binterplate/2.5);
%Vflux_obs_late = FrefV*10.^-(Vinterplate/2.5);
%rflux_obs_late = Frefrsloan*10.^-(rinterplate/2.5);
%Iflux_obs_late = FrefI*10.^-(Iinterplate/2.5);

Uflux_model = zeros(Nmodels,Ntimesmax);
Bflux_model = zeros(Nmodels,Ntimesmax);
Vflux_model = zeros(Nmodels,Ntimesmax);
Rflux_model = zeros(Nmodels,Ntimesmax);
Iflux_model = zeros(Nmodels,Ntimesmax);
Jflux_model = zeros(Nmodels,Ntimesmax);
Hflux_model = zeros(Nmodels,Ntimesmax);
Kflux_model = zeros(Nmodels,Ntimesmax);
S1flux_model = zeros(Nmodels,Ntimesmax);
S2flux_model = zeros(Nmodels,Ntimesmax);

Uflux_model_dc = zeros(Nmodels,Ntimesmax);
Bflux_model_dc = zeros(Nmodels,Ntimesmax);
Vflux_model_dc = zeros(Nmodels,Ntimesmax);
Rflux_model_dc = zeros(Nmodels,Ntimesmax);
Iflux_model_dc = zeros(Nmodels,Ntimesmax);
Jflux_model_dc = zeros(Nmodels,Ntimesmax);
Hflux_model_dc = zeros(Nmodels,Ntimesmax);
Kflux_model_dc = zeros(Nmodels,Ntimesmax);
S1flux_model_dc = zeros(Nmodels,Ntimesmax);
S2flux_model_dc = zeros(Nmodels,Ntimesmax);
   
for i = 1:Nmodels
    Uflux_model(i,1:Nepochs(i)) = FrefU*10.^-((A(i,1: Nepochs(i),Ucol(i)))/2.5); 
    Bflux_model(i,1:Nepochs(i)) = FrefB*10.^-((A(i,1: Nepochs(i),Bcol(i)))/2.5);
    Vflux_model(i,1:Nepochs(i)) = FrefV*10.^-((A(i,1: Nepochs(i),Vcol(i)))/2.5);
    Rflux_model(i,1:Nepochs(i)) = FrefR*10.^-((A(i,1: Nepochs(i),Rcol(i)))/2.5);
    Iflux_model(i,1:Nepochs(i)) = FrefI*10.^-((A(i,1: Nepochs(i),Icol(i)))/2.5);
    Jflux_model(i,1:Nepochs(i)) = FrefJ*10.^-((A(i,1: Nepochs(i),Jcol(i)))/2.5);
    Hflux_model(i,1:Nepochs(i)) = FrefH*10.^-((A(i,1: Nepochs(i),Hcol(i)))/2.5);
    %Kflux_model(i,1:Nepochs(i)) = FrefK*10.^-((A(i,1: Nepochs(i),Kcol(i)))/2.5);
    %S1flux_model(i,1:Nepochs(i)) = FrefS1*10.^-((A(i,1: Nepochs(i),S1col(i)))/2.5);
    %S2flux_model(i,1:Nepochs(i)) = FrefS2*10.^-((A(i,1:
    %Nepochs(i),S2col(i)))/2.5);
    Kflux_model(i,1:Nepochs(i)) = FrefK*10.^-(K_wdustandmol(i,1:Nepochs(i))/2.5);
    S1flux_model(i,1:Nepochs(i)) = FrefS1*10.^-(S1_wdustandmol(i,1:Nepochs(i))/2.5);
    S2flux_model(i,1:Nepochs(i)) = FrefS2*10.^-(S2_wdustandmol(i,1:Nepochs(i))/2.5);
        
end

% APPLY DEREDDENING ON OBSERVED PHOTOMETRY
          
Uflux_obs_dc = Uflux_obs*1.37;  % TEMP for EBV = 0.07
Bflux_obs_dc = Bflux_obs*1.30;
Vflux_obs_dc = Vflux_obs*1.22;
Rflux_obs_dc = Rflux_obs*1.18;
Iflux_obs_dc = Iflux_obs*1.13;
Jflux_obs_dc = Jflux_obs*1.059;
Hflux_obs_dc = Hflux_obs*1.036;
Kflux_obs_dc = Kflux_obs*1.024;
S1flux_obs_dc = S1flux_obs*1; %  TEMP
S2flux_obs_dc = S2flux_obs*1; %  TEMP
                              %Bflux_obs_late_dc = 1.30*Bflux_obs_late;
                              %Vflux_obs_late_dc = 1.22*Vflux_obs_late;
                              %rflux_obs_late_dc = 1.18*rflux_obs_late;
                              %Iflux_obs_late_dc = 1.13*Iflux_obs_late;

for i = 1:Nmodels
    Uflux_model_dc(i,:) = Uflux_model(i,:)*1.37  %The model
                                                 %magnitudes are
                                                 %dusted (to be
                                                 %comparable with
                                                 %observed ones)                                                                                    
    Bflux_model_dc(i,:) = Bflux_model(i,:)*1.30;
    Vflux_model_dc(i,:) = Vflux_model(i,:)*1.22;
    Rflux_model_dc(i,:) = Rflux_model(i,:)*1.18;
    Iflux_model_dc(i,:) = Iflux_model(i,:)*1.13;
    Jflux_model_dc(i,:) = Jflux_model(i,:)*1.059;
    Hflux_model_dc(i,:) = Hflux_model(i,:)*1.036;
    Kflux_model_dc(i,:) = Kflux_model(i,:)*1.024;
    S1flux_model_dc(i,:) = S1flux_model(i,:)*1; %  TEMP
    S2flux_model_dc(i,:) = S2flux_model(i,:)*1; %  TEMP
end

UBVRIJHKS1S2_obs =  0.5*(Uflux_obs+Bflux_obs)*(bandcenters(2)-bandcenters(1))... 
                  + 0.5*(Bflux_obs+Vflux_obs)*(bandcenters(3)-bandcenters(2))...
                  + 0.5*(Vflux_obs+Rflux_obs)*(bandcenters(4)-bandcenters(3))...
                  + 0.5*(Rflux_obs+Iflux_obs)*(bandcenters(5)-bandcenters(4))...
                  + 0.5*(Iflux_obs+Jflux_obs)*(bandcenters(6)-bandcenters(5))...
                  + 0.5*(Jflux_obs+Hflux_obs)*(bandcenters(7)-bandcenters(6))...
                  + 0.5*(Hflux_obs+Kflux_obs)*(bandcenters(8)-bandcenters(7))...
                  + 0.5*(Kflux_obs+S1flux_obs)*(bandcenters(9)-bandcenters(8))...
                  + 0.5*(S1flux_obs+S2flux_obs)*(bandcenters(10)-bandcenters(9));

UBVRIJHKS1S2_obs_dc =  0.5*(Uflux_obs_dc+Bflux_obs_dc)*(bandcenters(2)-bandcenters(1))...
                     + 0.5*(Bflux_obs_dc+Vflux_obs_dc)*(bandcenters(3)-bandcenters(2))...
                     + 0.5*(Vflux_obs_dc+Rflux_obs_dc)*(bandcenters(4)-bandcenters(3))...
                     + 0.5*(Rflux_obs_dc+Iflux_obs_dc)*(bandcenters(5)-bandcenters(4))...
                     + 0.5*(Iflux_obs_dc+Jflux_obs_dc)*(bandcenters(6)-bandcenters(5))...
                     + 0.5*(Jflux_obs_dc+Hflux_obs_dc)*(bandcenters(7)-bandcenters(6))...
                     + 0.5*(Hflux_obs_dc+Kflux_obs_dc)*(bandcenters(8)-bandcenters(7))...
                     + 0.5*(Kflux_obs_dc + S1flux_obs_dc)*(bandcenters(9)-bandcenters(8))...
                     + 0.5*(S1flux_obs_dc + S2flux_obs_dc)*(bandcenters(10)-bandcenters(9));

UBVRI_obs =  0.5*(Uflux_obs+Bflux_obs)*(bandcenters(2)-bandcenters(1)) ...  % Important must have dots!
           + 0.5*(Bflux_obs+Vflux_obs)*(bandcenters(3)-bandcenters(2)) ...
           + 0.5*(Vflux_obs+Rflux_obs)*(bandcenters(4)-bandcenters(3)) ...
           + 0.5*(Rflux_obs+Iflux_obs)*(bandcenters(5)-bandcenters(4));% + 0.5*(Iflux_obs+0)*(bandcenters(6)-bandcenters(5));

%[val,ind] = min(abs(tinterp-tinterplate(1)));

%UBVRI_obs_late_dc = 0.5*(Uflux_obs_dc(ind)*exp(-(tinterplate-tinterplate(1))/111.4)+Bflux_obs_late_dc)*(bandcenters(2)-bandcenters(1)) + 0.5*(Bflux_obs_late_dc + Vflux_obs_late_dc)*(bandcenters(3)-bandcenters(2)) + 0.5*(Vflux_obs_late_dc + rflux_obs_late_dc)*(bandcentersloanr-bandcenters(3)) + 0.5*(rflux_obs_late_dc + Iflux_obs_late_dc)*(bandcenters(5)-bandcentersloanr)% + 0.5*(Iflux_obs_late_dc + 0);

UBVRI_obs_dc =  0.5*(Uflux_obs_dc+Bflux_obs_dc)*(bandcenters(2)-bandcenters(1))...
              + 0.5*(Bflux_obs_dc+Vflux_obs_dc)*(bandcenters(3)-bandcenters(2))... 
              + 0.5*(Vflux_obs_dc+Rflux_obs_dc)*(bandcenters(4)-bandcenters(3))... 
              + 0.5*(Rflux_obs_dc+Iflux_obs_dc)*(bandcenters(5)-bandcenters(4)); % + 0.5*(Iflux_obs_dc+0)*(bandcenters(6)-bandcenters(5));


figure(1), clf, hold on

plot(tinterp,Uflux_obs_dc)
plot(tinterp,Bflux_obs_dc,'r')
plot(tinterp,Vflux_obs_dc,'k')
plot(tinterp,Rflux_obs_dc,'c')
plot(tinterp,Iflux_obs_dc,'m')
legend('U','B','V','R','I')

% MODELS PSEUDO-BOLOMETRIC LIGHT CURVES --------------------------

UBVRIJHKS1S2_model = zeros(Nmodels,Ntimesmax);
UBVRIJHKS1S2_model_dc = zeros(Nmodels,Ntimesmax);
UBVRI_model = zeros(Nmodels,Ntimesmax);
UBVRI_model_dc = zeros(Nmodels,Ntimesmax);

for i = 1:Nmodels
    
    UBVRIJHKS1S2_model(i,1:Nepochs(i)) = 0.5*(Uflux_model(i,1:Nepochs(i))+Bflux_model(i,1:Nepochs(i)))*(bandcenters(2)-bandcenters(1))...
                                       + 0.5*(Bflux_model(i,1:Nepochs(i))+Vflux_model(i,1:Nepochs(i)))*(bandcenters(3)-bandcenters(2))... 
                                       + 0.5*(Vflux_model(i,1:Nepochs(i))+Rflux_model(i,1:Nepochs(i)))*(bandcenters(4)-bandcenters(3))... 
                                       + 0.5*(Rflux_model(i,1:Nepochs(i))+Iflux_model(i,1:Nepochs(i)))*(bandcenters(5)-bandcenters(4))... 
                                       + 0.5*(Iflux_model(i,1:Nepochs(i))+Jflux_model(i,1:Nepochs(i)))*(bandcenters(6)-bandcenters(5))... 
                                       + 0.5*(Jflux_model(i,1:Nepochs(i))+Hflux_model(i,1:Nepochs(i)))*(bandcenters(7)-bandcenters(6))... 
                                       + 0.5*(Hflux_model(i,1:Nepochs(i))+Kflux_model(i,1:Nepochs(i)))*(bandcenters(8)-bandcenters(7))... 
                                       + 0.5*(Kflux_model(i,1:Nepochs(i))+S1flux_model(i,1:Nepochs(i)))*(bandcenters(9) - bandcenters(8))... 
                                       + 0.5*(S1flux_model(i,1:Nepochs(i))+S2flux_model(i,1:Nepochs(i)))*(bandcenters(10)-bandcenters(9))... 
                                       + lumSiO(i,1:Nepochs(i)).*(1-frac_fund_SiO(i,1:Nepochs(i)))/DF + lumCO(i,1:Nepochs(i))*1/DF;  % TEMP CO and SiO treatment

    UBVRIJHKS1S2_model_dc(i,1:Nepochs(i)) = 0.5*(Uflux_model_dc(i,1:Nepochs(i))+Bflux_model_dc(i,1:Nepochs(i)))*(bandcenters(2)-bandcenters(1))... 
                                          + 0.5*(Bflux_model_dc(i,1:Nepochs(i))+Vflux_model_dc(i,1:Nepochs(i)))*(bandcenters(3)-bandcenters(2))... 
                                          + 0.5*(Vflux_model_dc(i,1:Nepochs(i))+Rflux_model_dc(i,1:Nepochs(i)))*(bandcenters(4)-bandcenters(3))... 
                                          + 0.5*(Rflux_model_dc(i,1:Nepochs(i))+Iflux_model_dc(i,1:Nepochs(i)))*(bandcenters(5)-bandcenters(4))... 
                                          + 0.5*(Iflux_model_dc(i,1:Nepochs(i))+Jflux_model_dc(i,1:Nepochs(i)))*(bandcenters(6)-bandcenters(5))... 
                                          + 0.5*(Jflux_model_dc(i,1:Nepochs(i))+Hflux_model_dc(i,1:Nepochs(i)))*(bandcenters(7)-bandcenters(6))... 
                                          + 0.5*(Hflux_model_dc(i,1:Nepochs(i))+Kflux_model_dc(i,1:Nepochs(i)))*(bandcenters(8)-bandcenters(7))... 
                                          + 0.5*(Kflux_model_dc(i,1:Nepochs(i))+S1flux_model_dc(i,1:Nepochs(i)))*(bandcenters(9)-bandcenters(8))... 
                                          + 0.5*(S1flux_model_dc(i,1:Nepochs(i))+S2flux_model_dc(i,1:Nepochs(i)))*(bandcenters(10)-bandcenters(9))... 
                                          + lumSiO(i,1:Nepochs(i)).*(1-frac_fund_SiO(i,1:Nepochs(i)))/DF + lumCO(i,1:Nepochs(i))*1./DF;  % TEMP Co and SiO treatment

    UBVRI_model(i,1:Nepochs(i)) = 0.5*(Uflux_model(i,1:Nepochs(i))+Bflux_model(i,1:Nepochs(i)))*(bandcenters(2)-bandcenters(1))... 
                                + 0.5*(Bflux_model(i,1:Nepochs(i))+Vflux_model(i,1:Nepochs(i)))*(bandcenters(3)-bandcenters(2))... 
                                + 0.5*(Vflux_model(i,1:Nepochs(i))+Rflux_model(i,1:Nepochs(i)))*(bandcenters(4)-bandcenters(3))... 
                                + 0.5*(Rflux_model(i,1:Nepochs(i))+Iflux_model(i,1:Nepochs(i)))*(bandcenters(5)-bandcenters(4))...; % + 0.5*(Iflux_model(i,1:Nepochs(i))+0)*(bandcenters(6)-bandcenters(5));

    UBVRI_model_dc(i,1:Nepochs(i)) = 0.5*(Uflux_model_dc(i,1:Nepochs(i))+Bflux_model_dc(i,1:Nepochs(i)))*(bandcenters(2)-bandcenters(1))... 
                                   + 0.5*(Bflux_model_dc(i,1:Nepochs(i))+Vflux_model_dc(i,1:Nepochs(i)))*(bandcenters(3)-bandcenters(2))... 
                                   + 0.5*(Vflux_model_dc(i,1:Nepochs(i))+Rflux_model_dc(i,1:Nepochs(i)))*(bandcenters(4)-bandcenters(3))... 
                                   + 0.5*(Rflux_model_dc(i,1:Nepochs(i))+Iflux_model_dc(i,1:Nepochs(i)))*(bandcenters(5)-bandcenters(4)); % + 0.5*(Iflux_model_dc(i,1:Nepochs(i))+0)*(bandcenters(6)-bandcenters(5));

end

clear Asel;
%fileID = fopen('UBVRImodel52.txt','w');
%sel = 8;
%Asel = [A(sel,1:Nepochs(sel),2);UBVRI_model_dc(sel,1:Nepochs(sel))*DF];
%fprintf(fileID,'%6.2f %12.3e\n',Asel);
%fclose(fileID);
				      
figure(124), clf, hold on, box on % ------------------- UBVRI,
                                  % corrected for extinction
                                  % ----------------------------
subplot('Position',[0.13 0.15 0.78 0.75]), hold on, box on
lw1 = 5

mf = nimasswhensame/0.075;  % 0.14e41 Values below are for 0.07 Msun, scale up to 0.075

ind = find(tinterp <= 500);
h=plot(tinterp(ind), log10(DF*UBVRI_obs_dc(ind)./(mf*1.06e42*(exp(-tinterp(ind)/111.4)-exp(-tinterp(ind)/8.8)))),'r:','Linewidth',lw1)

                   
for i = 1:Nmodels
    ind = find(A(i,:,2) >= 100 & A(i,:,2) <= modelend);
    style = char(stylevec(i));
    color = char(colorvec(i));
    plot(A(i,ind,2), log10(DF*UBVRI_model_dc(i,ind)./(mf*1.06e42*(exp(-A(i,ind,2)/111.4)-exp(-A(i,ind,2)/8.8)))),'Linestyle',style','Color',color)
end
			  
ylabel('Log $L_{UBVRI}/L(0.075\ M_{\odot} ^{56}\mbox{Co}$)')
xlabel('Time (days)')
set(gca,'Ygrid','on')
set(gca,'Xgrid','on')
ylim([-2 0])
xlim([100 modelend+100])
set(gca,'Xminortick','on')
set(gca,'Yminortick','on')
title('$UBVRI$')
legend(Ms)
   
%tt = linspace(10,700);
%tau = 1*(tt/150.).^(-2);
%G = tau./(tau + 1.6);
%D = G.*(1 + 2*G.*(1-G).*(1-0.75*G));
% plot(tt,log10(0.4*D))
%text(timesU(length(timesU)),-1 ,'\leftarrow')
text('Interpreter','latex','Position',[timesU(length(timesU))-30,-1],'String','${\leftarrow}$ U','Fontsize',20)  
text('Interpreter','latex','Position',[timesI(length(timesI)-1)-30,-1],'String','${\leftarrow}$ I','Fontsize',20)  
%annotation('arrow',[timesU(length(timesU)) -1],[timesU(length(timesU)) -1]);
uistack(h,'top')

figure(123), clf, hold on, box on % ------------------- UBVRI,
                                  % corrected for extinction
                                  % ----------------------------
subplot('Position',[0.13 0.15 0.78 0.75]), hold on, box on
lw1 = 5


% DATA
%tcomb = [tinterp, tinterplate];  % Combine early and late data sets
%UBVRIJHKS1S2_obs_dc_comb = [UBVRIJHKS1S2_obs_dc, UBVRIJHKS1S2_obs_late_dc];

plot(tinterp, log10(DF*UBVRIJHKS1S2_obs_dc./(mf*1.06e42*(exp(-tinterp/111.4)-exp(-tinterp/8.8)))),'r:','Linewidth',lw1)
%plot(tinterplate, log10(DF*UBVRIJHKS1S2_obs_late_dc./(mf*1.06e42*(exp(-tinterplate/111.4)-exp(-tinterplate/8.8)))),'r:','Linewidth',lw1)
                    
for i = 1:Nmodels
     ind = find(A(i,:,2) >= 100 & A(i,:,2) <= modelend);
    style = char(stylevec(i));
    color = char(colorvec(i));
    plot(A(i,ind,2), log10(DF*UBVRIJHKS1S2_model_dc(i,ind)./(mf*1.06e42*(exp(-A(i,ind,2)/111.4)-exp(-A(i,ind,2)/8.8)))),'Linestyle',style','Color',color)
end
			  
ylabel('Log $L_{U-S_2}/L(0.075\ M_{\odot} ^{56}\mbox{Co}$)')
xlabel('Time (days)')
set(gca,'Ygrid','on')
set(gca,'Xgrid','on')
ylim([-1.6 0])
xlim([0 modelend+100])
set(gca,'Xminortick','on')
set(gca,'Yminortick','on')
title('$U-S_2$')
legend(Ms)
   
%tt = linspace(10,700);
%tau = 1*(tt/150.).^(-2);
%G = tau./(tau + 1.6);
%D = G.*(1 + 2*G.*(1-G).*(1-0.75*G));
% plot(tt,log10(0.4*D))
text('Interpreter','latex','Position',[timesH(length(timesH))-30,-0.8],'String','${\leftarrow}$ JHK','Fontsize',20)  

figure(125),clf, hold on, box on % ------SED 100 days, DUST CORRECTED -------------

  [val,sel_data] = min(abs(tinterp-100));  % 100 days
  [val,sel_model] = min(abs(A(main,:,2)-100));

  plot(bandcenters, [Uflux_obs_dc(sel_data), Bflux_obs_dc(sel_data), Vflux_obs_dc(sel_data), Rflux_obs_dc(sel_data), Iflux_obs_dc(sel_data), Jflux_obs_dc(sel_data), Hflux_obs_dc(sel_data), Kflux_obs_dc(sel_data), S1flux_obs_dc(sel_data), S2flux_obs_dc(sel_data)].*bandcenters,'r*-')

   if (A(main,sel_model,2) == 100)
       plot(bandcenters, [Uflux_model_dc(main,sel_model), Bflux_model_dc(main,sel_model), Vflux_model_dc(main,sel_model), Rflux_model_dc(main,sel_model), Iflux_model_dc(main,sel_model), Jflux_model_dc(main,sel_model), Hflux_model_dc(main,sel_model), Kflux_model_dc(main,sel_model),  S1flux_model_dc(main,sel_model), fluxS2_withmol(main,sel_model)].*bandcenters,'b*-')  % TEMP S2 is not dust corrected
       legend([M11,M2(main)])
   else
       legend(M11)
   end 
       
   set(gca,'Xscale','log')
   text(bandcenters(1)-200,0.55e-11,'U')
   text(bandcenters(2)-200,1.2e-11,'B')
   text(bandcenters(3)-200,2e-11,'V')
   text(bandcenters(4)-200,2.3e-11,'R')
   text(bandcenters(5)-200,2.4e-11,'I')
   text(bandcenters(6)-200,0.9e-11,'J')
   text(bandcenters(7)-200,0.7e-11,'H')
   text(bandcenters(8)-200,0.5e-11,'K')
   text(bandcenters(9)-200,0.3e-11,'S1')
   text(bandcenters(10)-200,0.5e-11,'S2')  
   title('100 d')
   xlabel('log \lambda')
   ylabel('F_\lambda \lambda')


figure(126),clf, hold on, box on % -------SED 200 days, DUST CORRECTED --------------
  
  time = 200;
  [val,sel_data] = min(abs(tinterp-time));  % 100 days
  [val,sel_model] = min(abs(A(main,:,2)-time));

  plot(bandcenters, [Uflux_obs_dc(sel_data), Bflux_obs_dc(sel_data), Vflux_obs_dc(sel_data), Rflux_obs_dc(sel_data), Iflux_obs_dc(sel_data), Jflux_obs_dc(sel_data), Hflux_obs_dc(sel_data), Kflux_obs_dc(sel_data), S1flux_obs_dc(sel_data), S2flux_obs_dc(sel_data)].*bandcenters,'r*-')

   if (A(main,sel_model,2) == time)
       plot(bandcenters, [Uflux_model_dc(main,sel_model), Bflux_model_dc(main,sel_model), Vflux_model_dc(main,sel_model), Rflux_model_dc(main,sel_model), Iflux_model_dc(main,sel_model), Jflux_model_dc(main,sel_model), Hflux_model_dc(main,sel_model), Kflux_model_dc(main,sel_model),  S1flux_model_dc(main,sel_model), S2flux_model_dc(main,sel_model)].*bandcenters,'b*-')
          legend([M11,M2(main)])
   else
       legend(M11)
   end 

   text(bandcenters(1),0.6e-12,'U')
   text(bandcenters(2),2e-12,'B')
   text(bandcenters(3),2.2e-12,'V')
   text(bandcenters(4),2.5e-12,'R')
   text(bandcenters(5),2.6e-12,'I')
   text(bandcenters(6),1e-12,'J')
   text(bandcenters(7),0.7e-12,'H')
   text(bandcenters(8),0.6e-12,'K')
   text(bandcenters(9),0.6e-12,'S1')
   text(bandcenters(10),0.6e-12,'S2')
   title('200 d')
   xlabel('log \lambda')
   ylabel('F_\lambda \lambda')
   set(gca,'Xscale','log')

figure(127),clf, hold on, box on % -----SED 300 days, DUST CORRECTED--------------

  time = 300;
  [val,sel_data] = min(abs(tinterp-time));  % 100 days
  sel_model = main;
  [val,sel_model] = min(abs(A(main,:,2)-time));

  plot(bandcenters, [Uflux_obs_dc(sel_data), Bflux_obs_dc(sel_data), Vflux_obs_dc(sel_data), Rflux_obs_dc(sel_data), Iflux_obs_dc(sel_data), Jflux_obs_dc(sel_data), Hflux_obs_dc(sel_data), Kflux_obs_dc(sel_data), S1flux_obs_dc(sel_data), S2flux_obs_dc(sel_data)].*bandcenters,'r*-')
 
   if (A(main,sel_model,2) == time)
       plot(bandcenters, [Uflux_model(main,sel_model), Bflux_model(main,sel_model), Vflux_model(main,sel_model), Rflux_model(main,sel_model), Iflux_model(main,sel_model), Jflux_model(main,sel_model), Hflux_model(main,sel_model), Kflux_model(main,sel_model),  S1flux_model(main,sel_model), S2flux_model(main,sel_model)].*bandcenters,'b*-')
          legend([M11,M2(main)])
   else
       legend(M11)
   end 

   text(bandcenters(1)-200,1.3e-13,'U')
   text(bandcenters(2)-200,5e-13,'B')
   text(bandcenters(3)-200,4.5e-13,'V')
   text(bandcenters(4)-200,8e-13,'R')
   text(bandcenters(5)-200,5.5e-13,'I')
   text(bandcenters(6)-200,2.3e-13,'J')
   text(bandcenters(7)-200,2.2e-13,'H')
   text(bandcenters(8)-200,1.2e-13,'K')
   text(bandcenters(9)-200,2e-13,'S1')
   text(bandcenters(10)-200,3e-13,'S2')
   title('300 d')
   xlabel('log \lambda')
   ylabel('F_\lambda \lambda')
   set(gca,'Xscale','log')

figure(128),clf, hold on, box on % -------SED 400 days, DUST
                                % CORRECTED------------
  time = 400;
  [val,sel_data] = min(abs(tinterp-time));  % 100 days
  sel_model = main;
  [val,sel_model] = min(abs(A(main,:,2)-time));

  plot(bandcenters, [Uflux_obs_dc(sel_data), Bflux_obs_dc(sel_data), Vflux_obs_dc(sel_data), Rflux_obs_dc(sel_data), Iflux_obs_dc(sel_data), Jflux_obs_dc(sel_data), Hflux_obs_dc(sel_data), Kflux_obs_dc(sel_data), S1flux_obs_dc(sel_data), S2flux_obs_dc(sel_data)].*bandcenters,'r*-')
 
   if (A(main,sel_model,2) == time)
       plot(bandcenters, [Uflux_model(main,sel_model), Bflux_model(main,sel_model), Vflux_model(main,sel_model), Rflux_model(main,sel_model), Iflux_model(main,sel_model), Jflux_model(main,sel_model), Hflux_model(main,sel_model), Kflux_model(main,sel_model),  S1flux_model(main,sel_model), S2flux_model(main,sel_model)].*bandcenters,'b*-')
          legend([M11,M2(main)])
   else
       legend(M11)
   end 

   text(bandcenters(1),0.6e-13,'U')
   text(bandcenters(2),1.3e-13,'B')
   text(bandcenters(3),1.3e-13,'V')
   text(bandcenters(4),2.0e-13,'R')
   text(bandcenters(5),1.1e-13,'I')
   text(bandcenters(6),0.5e-13,'J')
   text(bandcenters(7),0.6e-13,'H')
   text(bandcenters(8),0.3e-13,'K')
   text(bandcenters(9),0.4e-13,'S1')
   text(bandcenters(10),0.6e-13,'S2')
   title('400 d')
   xlabel('log \lambda')
   ylabel('F_\lambda \lambda')
   set(gca,'Xscale','log')

figure(130), clf, hold on, box on % ::::::::K BAND WITH AND WITHOUT
                                  % DUST FOR ONE OF THE MODELS::::::::::::::::::::::::::::::::::

 % DATA
 ind = find(PDATA(32,:) < 100);
 timesK = PDATA(1,ind)-JDE;
 dataK = PDATA(32,ind);
 errorbar(timesK, dataK-timesK/102.,PDATA(33,ind),'rd')

 % MODEL
 %for i = main:main
 %  ind = find(A(i,:,2) > 0.);
 %  style = char(stylevec(i));
 %  color = char(colorvec(i));
 plot(A(main,1:Nepochs(main),2), A(main,1:Nepochs(main),Kcol(i))-A(main,1:Nepochs(main),2)/102., 'Linestyle',':','Color','k')
 plot(A(main,1:Nepochs(main),2), K_WITHMOL(main,1:Nepochs(main))-A(main,1:Nepochs(main),2)/102., 'Linestyle','-','Color','k')
 %end
 plot(A(main,1:Nepochs(main),2), K_wdustandmol(main,1:Nepochs(main))-A(main,1:Nepochs(main),2)/102,'r--')
 %plot(A43(2,:),K_WITHCO_1-A43(2,:)/102.,'k')

 xlabel('Time (days)')
 ylabel('K - t/102^d')
 title('K')
 set(gca,'Ydir','Reverse')
 set(gca,'Xgrid','on')
 set(gca,'Ygrid','on')
 ylim([11 17])
 xlim([0 800])
% legend(Ms)
 legend('2011dh','atomic','atomic + CO', 'atomic + CO + dust')


fileID = fopen('apa.txt','w');
Ap = [tinterp;UBVRI_obs_dc*DF];
fprintf(fileID,'%6.2f %12.3e\n',Ap);
fclose(fileID);




  
